
MODULE graphics;

%include '/sys/ins/base.ins.pas';
%include '/sys/ins/gpr.ins.pas' ;
%include '/usr/include/tml/tml.ins.pas';

PROCEDURE tml_dp_damage_repair(VAR viewport_handle : tml_c_bitmap_id);

{ This procedure initializes newly displayed view_port objects. }
{ It must be included in EVERY Pascal program that uses TMLib.  }

CONST
    dp_damage_repair_index = 36;
VAR
    my_vpftbl    : tml_c_vpftbl;
    funcp        : GEN_FUNCP;
    intermed     : UNIV_PTR;
    procp        : ^PROCEDURE (viewport_handle : UNIV_PTR); OPTIONS(C_PARAM);

BEGIN

    my_vpftbl := tml_c_tml_dp_get_dflt_vpftbl;
    funcp     := tml_c_get_graf_func_from_table(my_vpftbl, dp_damage_repair_index);
    intermed  := funcp;
    procp     := intermed;
    procp^ (viewport_handle);

END;

PROCEDURE create_bitmap(OUT return_bitmap :gpr_$bitmap_desc_t);

{ This procedure creates a gpr bitmap
  in which graphics (tml text) can be output in }

VAR

mode:              gpr_$display_mode_t;
unit:              integer16;
disp:              gpr_$disp_char_t;
disp_len_passed:   integer16;
disp_len_returned: integer16;
bitmap_size:       gpr_$offset_t;
fg_value:          gpr_$pixel_value_t;
bg_value:          gpr_$pixel_value_t;
status:            status_$t;
unobsc:            boolean;

BEGIN
    bitmap_size.x_size := 1024;
    bitmap_size.y_size := 1024;

    { brook no interference from other gpr_$direct mode programs }
    unobsc := gpr_$acquire_display(status);

    { inquire number of planes in display                                 }
    { initializing gpr with this number of planes allows correct behavior }
    {   for both monochrome and color nodes                               }
    mode := gpr_$direct;
    unit := stream_$stdout;
    disp_len_passed := sizeof(gpr_$disp_char_t);
    gpr_$inq_disp_characteristics(mode, unit,
                                  disp_len_passed, disp, disp_len_returned,
                                  status);

    { initialize gpr }
    gpr_$init(mode, unit, bitmap_size, disp.n_planes, return_bitmap, status);

    { returned bitmap has default foreground and background settings    }
    {  -- reset to foreground and background values of DM window used   }
    { NOTE: the inquire calls work only in gpr direct (as here) and     }
    { in gpr frame mode. This code is not necessary in other gpr modes. }
    fg_value := gpr_$inq_foreground(status);
    bg_value := gpr_$inq_background(status);
    gpr_$set_text_value(fg_value, status);
    gpr_$set_text_background_value(bg_value, status);

    { release display }
    gpr_$release_display(status);

END;

