{ gpr_example_3b.pas }
PROGRAM gpr_example_3b;

%include '/sys/ins/base.ins.pas';
%include '/usr/include/tml/tml.ins.pas';
%include '/sys/ins/gpr.ins.pas';
%include '/sys/ins/kbd.ins.pas';

PROCEDURE create_bitmap(OUT return_bitmap : integer32); EXTERN;
PROCEDURE tml_dp_damage_repair(viewport_handle : tml_c_bitmap_id); EXTERN;
PROCEDURE enable_mouse; EXTERN;
PROCEDURE enable_all_keys; EXTERN;

VAR
    zero              :integer32     :=  0;
    filename          :array[0..8] of char;
    filename_length   :integer32;
    display_model     :TML_C_MODEL;
    display_viewport  :TML_C_VIEW_PORT;
    display_format    :TML_C_FORMAT;
    start_display     :C_MODEL_POS;
    p_start_display   :PTR_TO_C_MODEL_POS   := addr(start_display);
    bitmap            :integer32;

    dy                : INTEGER32;          { viewport height }
    dx                : INTEGER32;          { viewport width }
    inq_pos           : C_SCREEN_XY;        { any (x,y) coordinate on screen }
    p_inq_pos         : PTR_TO_C_SCREEN_XY  := addr(inq_pos);

    the_cursor        :TML_C_V_CURSOR;
    ev_type           :gpr_$event_t;
    ev_value          :CHAR;
    ret_coord         :gpr_$position_t ;
    status            :status_$t;
    unob              :BOOLEAN;
    curs_loc          :C_SCREEN_XY;
    p_curs_loc        :PTR_TO_C_SCREEN_XY   := addr(curs_loc);
    curs_pos          :C_MODEL_POS;
    p_curs_pos        :PTR_TO_C_MODEL_POS   := addr(curs_pos);
    old_top_line      :tml_c_cline;
    new_top_line      :tml_c_cline;
    first_line        :tml_c_cline;
    first_page        :tml_c_phead;
    at_coord          :C_XY_COORD;
    p_at_coord        :PTR_TO_C_XY_COORD    := addr(at_coord);
    on_phead          :tml_c_phead;
    in_cline          :tml_c_cline;
    in_char_set       :csm_c_char_set;
    use_font          :tml_c_font_tbl;
    char_val          :INTEGER32;
{************************************************************}
    hold_pos          :C_MODEL_POS;
    p_hold_pos        :PTR_TO_C_MODEL_POS   := addr(hold_pos);
    tab               :CHAR                 := chr(16#9);
    cr                :CHAR                 := chr(16#A);
    one               :integer32            := 1;
    dummy_pointer     :UNIV_PTR;
    at_char           :PTR_TO_CHAR;
{************************************************************}

    dummy_integer     :INTEGER32;
    dummy_format      :TML_C_FORMAT;

BEGIN

{ initialize TMLLIB }
tml_init;

{ associate all viewport objects with the GPR graphic system }
tml_c_tml_dp_set_dflt_vpftbl(tml_c_tml_dp_get_gpr_vpftbl());

{ create a model from the ASCII file test_file }
filename := 'test_file';
filename_length := SIZEOF(filename);
display_model := tml_c_read_uasc_path(filename[0], filename_length);

{ quit if model creation fails }
IF (display_model <> NIL) THEN
   BEGIN
   { allocate a viewport }
   display_viewport := view_port_class_alloc;

   { create a graphics display area }
   create_bitmap(bitmap);

   { assign display area to viewport }
   dummy_integer := view_port_set_handle(display_viewport,
                               tml_c_bitmap_id(addr(bitmap)));

   { create a format and attach it to viewport }
   dummy_format := NIL;
   dummy_integer := view_port_attach_format(display_viewport,
                                    dummy_format, zero, zero);

   { get a handle for the format created by the last call }
   display_format := view_port_get_format(display_viewport);

   { attach model to format that is associated with viewport }
   format_attach(display_format,display_model);

   { get root node of model }
   start_display.in_node := model_get_root(display_model);

   { quit on failure }
   IF (start_display.in_node <> NIL) THEN
      BEGIN
      start_display.char_index := 0;

      { display top of file }
      tml_dp_damage_repair(view_port_get_handle(display_viewport));

      { allocate cursor }
      the_cursor := v_cursor_class_alloc;
      IF (the_cursor <> NIL) THEN
        BEGIN
        dummy_integer := view_port_attach_cursor(display_viewport,
                                                 the_cursor, zero_zero);
        dummy_integer := v_cursor_enable(the_cursor, zero);
        enable_mouse();
        enable_all_keys();

        REPEAT
          unob := gpr_$event_wait(ev_type, ev_value, ret_coord, status);

          CASE ev_type OF

            gpr_$buttons:
            { Mouse Button Press }

              CASE ev_value OF

                 { Left mouse down }
                 KBD_$M1D:
                    BEGIN
                    { move TMLib cursor to location of pointing cursor }
                    {   at click }
                    inq_pos.at_x := ret_coord.x_coord;
                    inq_pos.at_y := ret_coord.y_coord;
                    dummy_integer := v_cursor_xy_set(the_cursor,
                                                     inq_pos);
                    END;

              END;

            gpr_$keystroke:
            { Key Press }

              CASE ev_value OF

                 KBD_$LD:
                    BEGIN
                    { up-box-arrow key: scroll up half a viewport }
                    { get (x,y) position of cursor in viewport }
                    p_curs_loc :=
                      v_cursor_get_raw_location(the_cursor, curs_loc);
                    { get height of viewport -- it may have changed }
                    dy := view_port_get_hi(display_viewport);
                    { get top line of viewport }
                    old_top_line :=
                      view_pos_get_cline(
                        view_port_get_top_line(display_viewport));
                    { find the character if any at top of viewport }
                    p_start_display :=
                      view_port_xy_2_mpos(display_viewport,
                                          zero_zero, start_display);
                    { if a character was found }
                    {  display it halfway down the screen }
                    IF (start_display.in_node <> NIL) THEN
                       BEGIN
                       p_inq_pos :=
                         view_port_mpos_2_xy(display_viewport,
                                             start_display, inq_pos, NIL);
                       inq_pos.at_y := dy div 2;
                       view_port_draw_at(display_viewport,
                                         start_display, inq_pos);
                       { if cursor character not on screen, }
                       {  set cursor at position it had before scroll }
                       p_curs_pos :=
                         v_cursor_get_model_pos(the_cursor, curs_pos);
                       IF (view_port_mpos_2_vpos(display_viewport,
                           curs_pos) = NIL ) THEN
                          dummy_integer := v_cursor_xy_set(the_cursor,
                                                           curs_loc);
                       END;
                    { if no movement and line above exists, }
                    {   go to top of file }
                    { get new top line of viewport }
                    new_top_line :=
                      view_pos_get_cline(
                        view_port_get_top_line(display_viewport));
                    if ((new_top_line <> NIL) AND
                     (new_top_line = old_top_line) AND
                     (cline_get_prior(new_top_line) <> NIL)) THEN
                       BEGIN
                       { no movement and prior line exists }
                       { get first position in model }
                       start_display.in_node :=
                         model_get_root(format_get_model(display_format));
                       start_display.char_index := 0;
                       p_start_display :=
                         model_pos_get_next(start_display, start_display);
                       { get and correct position of first position }
                       {   on its conceptual page }
                       first_page :=
                         format_mpos_2_phead(display_format, start_display);
                       first_line :=
                         phead_mpos_2_cline(first_page, start_display);
                       p_at_coord :=
                         cline_mpos_2_xy(first_line,
                                         start_display, at_coord);
                       inq_pos.at_x := at_coord.x_coord
                         + view_port_get_hoffset(display_viewport);
                       inq_pos.at_y := 0;
                       view_port_draw_at(display_viewport,
                                         start_display, inq_pos);
                       { if cursor character not on screen, }
                       {  set cursor at position it had before scroll }
                       p_curs_pos :=
                         v_cursor_get_model_pos(the_cursor, curs_pos);
                       IF (view_port_mpos_2_vpos(display_viewport,
                           curs_pos) = NIL ) THEN
                          dummy_integer := v_cursor_xy_set(the_cursor,
                                                           curs_loc);
                       END;
                    END;

                 KBD_$LF:
                    BEGIN
                    { down-box arrow key: scroll down half a viewport }
                    { get (x,y) position of cursor in viewport }
                    p_curs_loc :=
                      v_cursor_get_raw_location(the_cursor, curs_loc);
                    { get height of viewport -- it may have changed }
                    dy := view_port_get_hi(display_viewport);
                    { find character halfway down and furthest left }
                    inq_pos.at_x := 0;
                    inq_pos.at_y := dy div 2;
                    p_start_display :=
                      view_port_xy_2_mpos(display_viewport,
                                          inq_pos, start_display);
                    { if character found, display at top of viewport }
                    IF (start_display.in_node <> NIL) THEN
                       BEGIN
                       { get true location of character }
                       p_inq_pos :=
                         view_port_mpos_2_xy(display_viewport,
                                             start_display, inq_pos, NIL);
                       inq_pos.at_y := 0;
                       { draw first character at new coordinates }
                       view_port_draw_at(display_viewport,
                                         start_display, inq_pos);
                       { if cursor character not on screen, }
                       {  set cursor at position it had before scroll }
                       p_curs_pos :=
                         v_cursor_get_model_pos(the_cursor, curs_pos);
                       IF (view_port_mpos_2_vpos(display_viewport,
                           curs_pos) = NIL ) THEN
                          dummy_integer := v_cursor_xy_set(the_cursor,
                                                           curs_loc);
                       END;
                    END;

                 KBD_$L7:
                    BEGIN
                    { left-box arrow key: scroll left 1/4 viewport width }
                    { get (x,y) position of cursor in viewport }
                    p_curs_loc :=
                      v_cursor_get_raw_location(the_cursor, curs_loc);
                    { get width of the viewport -- it may have changed }
                    dx := view_port_get_width(display_viewport);
                    { find character at pixel (0,0) }
                    p_start_display :=
                      view_port_xy_2_mpos(display_viewport,
                                          zero_zero, start_display);
                    IF (start_display.in_node <> NIL) THEN
                       BEGIN
                       { get (x,y) of topmost character }
                       p_inq_pos :=
                         view_port_mpos_2_xy(display_viewport,
                                             start_display, inq_pos, NIL);
                       { increment x coordinate by 1/4 viewport width }
                       inq_pos.at_x := inq_pos.at_x + (dx div 4);
                       view_port_draw_at(display_viewport,
                                         start_display, inq_pos);
                       { if cursor character not on screen, }
                       {  set cursor at position it had before scroll }
                       p_inq_pos :=
                         v_cursor_get_caged_location(the_cursor, inq_pos);
                       IF (inq_pos.at_x > dx) THEN
                            dummy_integer := v_cursor_xy_set(the_cursor,
                                                             curs_loc);
                       END;
                    END;

                 KBD_$L9:
                    BEGIN
                    { right-box arrow key -- scroll right 1/4 viewport width }
                    { get (x,y) position of cursor }
                    p_curs_loc :=
                      v_cursor_get_raw_location(the_cursor, curs_loc);
                    { get width of viewport -- it may have changed }
                    dx := view_port_get_width(display_viewport);
                    { find character at pixel (0,0) }
                    p_start_display :=
                      view_port_xy_2_mpos(display_viewport,
                                          zero_zero, start_display);
                    IF (start_display.in_node <> NIL) THEN
                       BEGIN
                       { get (x,y) of topmost character }
                       p_inq_pos :=
                         view_port_mpos_2_xy(display_viewport,
                                             start_display, inq_pos, NIL);
                       { decrement x coordinate by 1/4 viewport width }
                       inq_pos.at_x := inq_pos.at_x - (dx div 4);
                       { display at new coordinates }
                       view_port_draw_at(display_viewport,
                                         start_display, inq_pos);
                       { if cursor character not on screen, }
                       {  set cursor at position it had before scroll }
                       p_inq_pos :=
                         v_cursor_get_caged_location(the_cursor, inq_pos);
                       IF (inq_pos.at_x < 0) THEN
                            dummy_integer := v_cursor_xy_set(the_cursor,
                                                             curs_loc);
                       p_curs_loc := 
                         v_cursor_get_raw_location(the_cursor, curs_loc);
                       p_curs_pos := 
                         v_cursor_get_model_pos(the_cursor, curs_pos);
                       IF (curs_loc.at_x < 0) THEN
                       BEGIN
                          { reset cursor to right edge of character }
                          {   if left edge is off screen }
                          on_phead := 
                            format_mpos_2_phead(display_format, 
                                                curs_pos);
                          in_cline := 
                            phead_mpos_2_cline(on_phead, curs_pos);
                          in_char_set := 
                            model_inq_state_at_node(
                              display_model,
                              curs_pos.in_node, tml_char_set_prop);
                          dummy_pointer := node_get_contents(curs_pos.in_node);
                          dummy_integer := integer32(dummy_pointer);
                          dummy_integer := dummy_integer + curs_pos.char_index;
                          dummy_pointer := univ_ptr(dummy_integer);
                          at_char := dummy_pointer;
                          char_val := csm_c_char_set_as_ulong(
                            in_char_set,
                            at_char^);
                          use_font := tline_get_font(in_cline);
                          curs_loc.at_x := curs_loc.at_x
                            + font_tbl_get_width(use_font, char_val)
                            + font_tbl_get_icspace(use_font);
                          dummy_integer := 
                            v_cursor_xy_set(the_cursor, curs_loc);
                          END;
                       END;
                    END;

                 KBD_$R5:
                    BEGIN
                    { exit key: exit the program }
                    { release dynamically allocated storage }
                    { freeing viewport frees cursor }
                    view_port_free(display_viewport);
                    { delete format }
                    format_free(display_format);
                    { delete model }
                    model_free(display_model);
                    EXIT;
                    END;

{************************************************************}
                 KBD_$BS:
                    BEGIN
                    { backspace key: delete character to left }
                    {  of TMLib cursor }
                    { try to move cursor left }
                    p_curs_pos :=
                      v_cursor_get_model_pos(the_cursor, curs_pos);
                    p_curs_loc :=
                      v_cursor_move(the_cursor, vp_left, curs_loc);
                    p_hold_pos :=
                      v_cursor_get_model_pos(the_cursor, hold_pos);
                    { quit on failure to move }
                    {  (cursor at top of file) }
                    IF (model_pos_eq(curs_pos, hold_pos) = 0) THEN
                       BEGIN
                       { delete character }
                       dummy_integer :=
                         view_port_delete_char(display_viewport, hold_pos);
                       { resetting cursor updates its model position }
                       dummy_integer :=
                         v_cursor_xy_set(the_cursor, curs_loc);
                       END;
                    END;

                 KBD_$CR:
                    { carriage return key: insert a return after cursor }
                    BEGIN
                    dummy_integer := view_port_ins_after_cursor
                                       (display_viewport, cr, one);
                    END;

                 KBD_$TAB:
                    { tab key: insert a tab after cursor }
                    BEGIN
                    dummy_integer := view_port_ins_after_cursor
                                       (display_viewport, tab, one);
                    END;

                 OTHERWISE
                    { any other key: insert character }
                    BEGIN
                    dummy_integer := view_port_ins_after_cursor
                                 (display_viewport, ev_value, one);
                    END;
{************************************************************}

              END;

          END;

        UNTIL FALSE;

        END
        ELSE writeln('unable to allocate a cursor');

      END;

   END;

END.
