/* tml_x_exam_kbd.h                               */
/* Header containing XWindows keysym value macros */
/*   used in TMLib XWindows examples.             */
/* Table of scroll and exit keys:                 */
/*                                                */
/*   Apollo keyboards                             */
/*      UpBox, DownBox, LeftBox, RightBox, Exit   */
/*   non-Apollo Hewlett-Packard keyboards         */
/*      Up,    Down,    Left,    Right,    Stop   */
/*   Sun keyboards                                */
/*      Up,    Down,    Left,    Right,    L1     */

#ifndef tml_x_exam_kbd_h
#define tml_x_exam_kbd_h

#include <X11/keysym.h>

#define tmlReturn       XK_Return
#define tmlBackspace    XK_BackSpace

#ifdef apollo
#include <X11/ap_keysym.h>

#define tmlScrollUp     apXK_UpBox
#define tmlScrollDown   apXK_DownBox
#define tmlScrollLeft   apXK_LeftBox
#define tmlScrollRight  apXK_RightBox
#define tmlExit         apXK_Exit

#else

#define tmlScrollUp     XK_Up
#define tmlScrollDown   XK_Down
#define tmlScrollLeft   XK_Left
#define tmlScrollRight  XK_Right

#ifdef hpux
#define tmlExit         XK_Cancel
#endif

#ifdef sun
#define tmlExit         XK_L1
#endif

#endif

#endif
/* tml_x_exam_kbd_h */
