/**************************************************************************************
    aegis_re_wrap.c
    C language wrapper for regular expression search functionality

    (c) Copyright Apollo Computer Inc., 1987 (unpublished)
     --------------------------------------------------------------------
    |THE FOLLOWING PROGRAMS ARE THE SOLE PROPERTY OF APOLLO COMPUTER INC.|
    |      AND CONTAIN ITS PROPRIETARY AND CONFIDENTIAL INFORMATION.     |
     --------------------------------------------------------------------
**************************************************************************************/


#include <apollo/base.h>

extern char* tml_aegis_re_compile(char*, short, short);
extern short tml_aegis_re_match(char*, short, char*);
extern short tml_aegis_min_match_len(char*);

char* tml_aegis_compile_re(compile_st, compile_len, case_sens)
char  *compile_st;
long     compile_len;
long     case_sens;
{
    return (tml_aegis_re_compile(compile_st, (short)compile_len, (short)case_sens));
}

long    tml_aegis_match_re(search_st, search_st_len, use_pat)
char  *search_st;
long search_st_len;
char  *use_pat;
{
    register long return_index;
                                
    /*tml_aegis_re_match returns a 1 based offset into the string*/
    return_index = tml_aegis_re_match(search_st, (short)search_st_len, use_pat);
    /*change the 1 based offset to a zero based offset*/
    return_index--;
    return return_index;
}

long tml_aegis_min_match(void* pattern)
{
    return(tml_aegis_min_match_len(pattern));
}

