(**************************************************************************************
    aegis_re_wrap.pas
    pascal wrapper for regular expression search functionality

    (c) Copyright Apollo Computer Inc., 1987 (unpublished)
     --------------------------------------------------------------------
    |THE FOLLOWING PROGRAMS ARE THE SOLE PROPERTY OF APOLLO COMPUTER INC.|
    |      AND CONTAIN ITS PROPRIETARY AND CONFIDENTIAL INFORMATION.     |
     --------------------------------------------------------------------
**************************************************************************************)

    
module aegis_search;
   
DEFINE tml_aegis_re_compile,
            tml_aegis_re_match,
            tml_aegis_min_match_len;

%include '/sys/ins/base.ins.pas';
%include '/us/ins/re.ins.pas';

{CONST tml_max_match_string = 4096;    maximum length of string to be searched by re_$match}
CONST   tml_max_pattern_size = 512;     {maximum size of compiled search pattern}


FUNCTION tml_aegis_re_compile(
    IN re:    UNIV re_$string_t;
    IN re_len: integer;
    IN c_sen : integer
    ) : re_$pattern_t; EXTERN;
                                         
FUNCTION tml_aegis_re_match(
    in re  :   UNIV re_$string_t;
    IN re_len : integer;
    IN pat   : UNIV re_$pattern_t
    ) : integer; EXTERN;

FUNCTION tml_aegis_min_match_len(
    IN pattern  : UNIV re_$pattern_t
    ) : integer; EXTERN;

                                           
FUNCTION tml_aegis_min_match_len;
BEGIN
    tml_aegis_min_match_len := ord(pattern[2].i) - 1;
END;

FUNCTION tml_aegis_re_compile;
VAR
    pattern_made   : re_$pattern_t;
    cs                 : re_$case_sens_t;
    has_wild        : boolean;
    junk               : integer;
    status            : status_$t;

BEGIN
    IF c_sen = 0 THEN
        cs := re_$case_insensitive
    ELSE
        cs := re_$case_sensitive;
    has_wild := re_$chk_wild(re, re_len, junk);
    re_$make_pattern(re, re_len, 1, chr(0), pattern_made, tml_max_pattern_size, cs, has_wild, status);
    tml_aegis_re_compile := pattern_made
END;


FUNCTION tml_aegis_re_match;
VAR
    return_tags    :   re_$tag_list_t;
BEGIN
    tml_aegis_re_match := re_$match(re, re_len, pat, return_tags);
END;
