/**************************************************************************************
    arch_neutral.hxx
    header file defining constants for the architecture-neutral
      components of the text management library.

    (c) Copyright Apollo Computer Inc., 1989 (unpublished)
     --------------------------------------------------------------------
    |THE FOLLOWING PROGRAMS ARE THE SOLE PROPERTY OF APOLLO COMPUTER INC.|
    |      AND CONTAIN ITS PROPRIETARY AND CONFIDENTIAL INFORMATION.     |
     --------------------------------------------------------------------
**************************************************************************************/

#ifndef arch_neutral_hxx
#define arch_neutral_hxx

/**********************************************************************************
    Declarations establishing independence from pointer/integer conversion
      peculiarities of heterogeneous compiler architectures
**********************************************************************************/

#ifdef ptr_32_int_16
#else
#ifdef ptr_16_int_16
#else
#ifdef ptr_16_int_32
#else                    // ptr_32_int_32
typedef unsigned long tml_uint32;
typedef unsigned short tml_ushort16;
typedef tml_uint32 WHOLE_PTR;    //assuming a pointer of unsigned 32 bits,
typedef tml_ushort16 HALF_PTR;   // assume half a pointer of unsigned 16 bits
const BITS_IN_HALF_PTR = 16;
const HALF_PTR_MASK = 0x0000FFFF;
#endif
#endif
#endif

typedef char* CHARP;
typedef long (*PFI)();

#endif 
// arch_neutral_hxx

