/**************************************************************************************
    File csm_cxx2.0_linkage_decls.hxx
    Function declarations to externalize CSM calls
        for use within CSM

    (c) Copyright Apollo Computer Inc., 1990 (unpublished)
     --------------------------------------------------------------------
    |THE FOLLOWING PROGRAMS ARE THE SOLE PROPERTY OF APOLLO COMPUTER INC.|
    |      AND CONTAIN ITS PROPRIETARY AND CONFIDENTIAL INFORMATION.     |
     --------------------------------------------------------------------
**************************************************************************************/

#ifndef csm_cxx_2_0_linkage_decls_hxx
#define csm_cxx_2_0_linkage_decls_hxx

/* extern declaration satisfies C++ 2.0 demand that all externally */
/*   visible entry points be explicitly declared. This is required */
/*   for csm_inlib_entry() to be used as an alternate entry point. */
#ifdef __cplusplus
    typedef void* csm_c_char_set;
    extern "C" {

        /* functions declared in CSM code proper */
        void  csm_inlib_entry();
        long  char_set_get_dir_to_char(csm_c_char_set, unsigned char*);
        int   posix_bre_yylex();
        int   posix_bre_yyerror(char*);
        int   posix_bre_yyparse();
        int   posix_ere_yylex();
        int   posix_ere_yyerror(char*);
        int   posix_ere_yyparse();

        void  posix_re_truncate(unsigned long);
        void  posix_re_make_sibling(long, long);
        void  posix_re_make_subtree(long, long, long);
        void  posix_re_make_counted_expr();

        /* functions from operating-system independent */
        /*   input/output interface */
        void* tml_os_open(char*, long, long, long);
        long  tml_os_close(void*);
        long  tml_os_read(void*, char*, unsigned long);
        long  tml_os_write(void*, char*, unsigned long);
        long  tml_os_rewind(void*);

        /* functions from operating-system independent */
        /*   utility interface */
        void  tml_os_qsort(char*, unsigned long, unsigned long, long (*)(void*, void*));

        /* functions from C interface to operating-system independent */
        /*   utility interface */
        char* tml_c_tml_os_alloc(unsigned long nelem, unsigned long elsize);
        void  tml_c_tml_os_free(char* ptr);
        char* tml_c_tml_os_byte_copy(char* from, char* to, long count);
        }

#endif
/* __cplusplus */

#endif
/* csm_cxx2_0_linkage_decls_hxx */

