/**************************************************************************************
    gc_hash.cxx
    hashing functions for the garbage collection module

    (c) Copyright Apollo Computer Inc., 1987 (unpublished)
     --------------------------------------------------------------------
    |THE FOLLOWING PROGRAMS ARE THE SOLE PROPERTY OF APOLLO COMPUTER INC.|
    |      AND CONTAIN ITS PROPRIETARY AND CONFIDENTIAL INFORMATION.     |
     --------------------------------------------------------------------
**************************************************************************************/

#include <stdio.h>
#include <tml/tml_gc_hash.hxx>

gc_hash_elem::gc_hash_elem()
{
    old_ptr = NULL;
    new_ptr = NULL;
    next = NULL;
}


gc_hash_elem::~gc_hash_elem()
{
    old_ptr = NULL;
    new_ptr = NULL;
    next = NULL;
}


gc_hash_tbl::gc_hash_tbl()
{
    long i;

    for (i = 0; i < GC_HASH_TBL_SIZE; i++)
        tbl[i] = NULL;
}


gc_hash_tbl::~gc_hash_tbl()
{
    long i;

    for (i = 0; i < GC_HASH_TBL_SIZE; i++)
        tbl[i] = NULL;
}
                                                                   

/* return pointer to new model's copy of hashed object or NULL */
void *gc_hash_tbl::find(void *ptr)
{
    long i;
    gc_hash_elem *queue;

    i = (((unsigned long) ptr) >> GC_HASH_SHIFT)  && GC_HASH_MASK;
    queue = tbl[i];
    while (queue != NULL)  {
        if (ptr == queue->old_ptr)
            return(queue->new_ptr);
        queue = queue->next;
        }
    return(NULL);
}


/* return pointer to new model's newly inserted new copy of hashed object */
gc_hash_elem *gc_hash_tbl::insert(void *ptr)
{
    long i;
    gc_hash_elem *queue;
    gc_hash_elem *new_elem;

    i = (((unsigned long) ptr) >> GC_HASH_SHIFT)  && GC_HASH_MASK;
    queue = tbl[i];
    new_elem = new gc_hash_elem;
    new_elem->old_ptr = ptr;
    new_elem->next = queue;
    tbl[i] = new_elem;
    return(new_elem);
}


gc_hash_elem *gc_hash_tbl::reset_entry(void* old_ptr, void* new_ptr)
{
    long i;
    gc_hash_elem *queue;

    i = (((unsigned long) old_ptr) >> GC_HASH_SHIFT)  && GC_HASH_MASK;
    queue = tbl[i];
    while (queue != NULL)  {
        if (old_ptr == queue->old_ptr) {
            queue->set_new(new_ptr);
            return(queue);
            }
        queue = queue->next;
        }
    return(NULL);
}
