/**************************************************************************************
    post_filter.hxx
    Header file for tml postscript filter

    (c) Copyright Apollo Computer Inc., 1987 (unpublished)
     --------------------------------------------------------------------
    |THE FOLLOWING PROGRAMS ARE THE SOLE PROPERTY OF APOLLO COMPUTER INC.|
    |      AND CONTAIN ITS PROPRIETARY AND CONFIDENTIAL INFORMATION.     |
     --------------------------------------------------------------------
**************************************************************************************/

/*
  Changes:
    1/28/88  created from filter_objects.hxx
*/
   
#ifndef post_filter_hxx
#define post_filter_hxx

//
//  Object to convert tml stream to postscript.
//
//  Assumptions: - input stream is open and positioned to BOF on entry
//               - input stream is closed on exit
//               - output stream is left open and rewound on exit
//

class post_filter
{
   char   *io_buff;
   short  num_cols, pg_layout, broken_line;
   long   pt_size, delta_x, delta_y, max_xcoord, rel_move, *page_size;
   char*  get_iso (unsigned char, long*);
   long   set_pg_coord ( phead*, model_pos*, print_db* );
   long   write_header ( long*, print_db*  );
   void   add_poststr ( char*, long* lgt );
   void   build_poststr (font_tbl*, print_db*, long, long );
   long   float_round (long, long, long);
   void   scale_widths (model*, print_db*);
   long   f__read ( char*, model_pos*, long );
   long   f__write ( char*, long*, long );

public:
          post_filter () {io_buff=new char[4096];page_size=new long[2];}
          ~post_filter () {delete io_buff;delete page_size;}
   long   filter ( model*, void*, print_db*);
};
                   

#endif
// post_filter_hxx
