(*****************************************************************************
    tml.ins.pas -- header file including Pascal language interface for the
    object definitions and assorted type declarations for the portable
    version of the text management library.

    (c) Copyright Apollo Computer Inc., 1987 (unpublished)
     --------------------------------------------------------------------
    |THE FOLLOWING PROGRAMS ARE THE SOLE PROPERTY OF APOLLO COMPUTER INC.|
    |      AND CONTAIN ITS PROPRIETARY AND CONFIDENTIAL INFORMATION.     |
     --------------------------------------------------------------------
*****************************************************************************)


%include '/usr/include/tml/csm.ins.pas';
%include '/usr/include/tml/tml_structs.ins.pas';

(******************************************************************************
   TYPEs for C++ classes

******************************************************************************)


TYPE tml_c_node                = UNIV_PTR;

TYPE tml_c_bnode               = UNIV_PTR;

TYPE tml_c_gnode               = UNIV_PTR;

TYPE tml_c_draw_mark           = UNIV_PTR;

TYPE tml_c_model               = UNIV_PTR;

TYPE tml_c_prop_vec            = UNIV_PTR;

TYPE tml_c_property            = UNIV_PTR;

TYPE tml_c_argument            = UNIV_PTR;

TYPE tml_c_history             = UNIV_PTR;

TYPE tml_c_prop_func_ent       = UNIV_PTR;

TYPE tml_c_format              = UNIV_PTR;

TYPE tml_c_cline               = UNIV_PTR;

TYPE tml_c_tline               = UNIV_PTR;

TYPE tml_c_phead               = UNIV_PTR;

TYPE tml_c_font_tbl            = UNIV_PTR;

TYPE tml_c_view_pos            = UNIV_PTR;

TYPE tml_c_v_cursor            = UNIV_PTR;

TYPE tml_c_view_port           = UNIV_PTR;

TYPE tml_c_bitmap_id           = UNIV_PTR;

TYPE tml_c_vpftbl              = UNIV_PTR;

TYPE tml_c_grafsys             = UNIV_PTR;

(******************************************************************************
   TYPEs and instances for extensibility

******************************************************************************)


TYPE node_type                 = UNIV_PTR;

TYPE p_index                   = UNIV_PTR;

TYPE arg_type                  = UNIV_PTR;

VAR undefined_node             : EXTERN node_type;
VAR bobj                       : EXTERN node_type;
VAR branch                     : EXTERN node_type;
VAR gobj                       : EXTERN node_type;
VAR pgobj                      : EXTERN node_type;
VAR leaf                       : EXTERN node_type;
VAR is_free                    : EXTERN node_type;

VAR undefined_prop             : EXTERN p_index;
VAR tml_wrap_prop              : EXTERN p_index;
VAR tml_margin_prop            : EXTERN p_index;
VAR tml_font_prop              : EXTERN p_index;
VAR tml_inv_prop               : EXTERN p_index;
VAR tml_pgsize_prop            : EXTERN p_index;
VAR tml_header_prop            : EXTERN p_index;
VAR tml_footer_prop            : EXTERN p_index;
VAR tml_form_feed_prop         : EXTERN p_index;
VAR tml_char_set_prop          : EXTERN p_index;
VAR tml_union_char_set_prop    : EXTERN p_index;
VAR tml_tab_prop               : EXTERN p_index;

VAR int_val_arg                : EXTERN arg_type;
VAR float_val_arg              : EXTERN arg_type;
VAR string_val_arg             : EXTERN arg_type;
VAR no_val_arg                 : EXTERN arg_type;
VAR subtree_val_arg            : EXTERN arg_type;
VAR char_set_val_arg           : EXTERN arg_type;
VAR union_char_set_val_arg     : EXTERN arg_type;

(******************************************************************************
    constants used in the classes

******************************************************************************)


(* BOOLEAN REFERENCES FOR PROPERTY VALUES *)


CONST tml_true_prop            = 1;

CONST tml_false_prop           = 0;
    


(******************************************************************************
    Enumerated types

******************************************************************************)

(* ENUMERATED CLASS OF DIRECTIONS FROM ONE NODE TO ANOTHER *)
(* enum node_dir {n_up, n_right, n_left, n_down}; *)
CONST n_up                     = 0;
CONST n_right                  = 1;
CONST n_left                   = 2;
CONST n_down                   = 3;
TYPE node_dir                  = INTEGER32;



(* ENUMERATED CLASS OF TYPES OF VALUES FOR TML VERSION 1 CLASS ARGUMENT *)
(* enum arg_type_v1 {int_val, float_val, string_val, no_val}; *)
CONST int_val                  = 0;
CONST float_val                = 1;
CONST string_val               = 2;
CONST no_val                   = 3;
TYPE arg_type_v1               = INTEGER32;



(* ENUMERATED CLASS OF TYPES OF CONCEPTUAL LINES *)
(* enum  cl_type {cl_free, cl_text, cl_graphic, cl_blank, cl_gutter, cl_other}; *)
CONST cl_free                  = 0;
CONST cl_text                  = 1;
CONST cl_graphic               = 2;
CONST cl_blank                 = 3;
CONST cl_gutter                = 4;
CONST cl_other                 = 5;
TYPE cl_type                   = INTEGER32;



(* ENUMERATED CLASS OF THE DIRECTIONS THE CURSOR CAN MOVE *)
(* enum vp_dir {vp_right, vp_left, vp_up, vp_down,
                vp_begin_line, vp_end_line, vp_top, vp_bottom}; *)
CONST vp_right                 = 0;
CONST vp_left                  = 1;
CONST vp_up                    = 2;
CONST vp_down                  = 3;
CONST vp_begin_line            = 4;
CONST vp_end_line              = 5;
CONST vp_top                   = 6;
CONST vp_bottom                = 7;
TYPE vp_dir                    = INTEGER32;



(* ENUMERATED CLASS OF PRINTING ORIENTATIONS *)
(* enum orientation {portrait, landscape} *)
CONST portrait                 = 0;
CONST landscape                = 1;
TYPE orientation               = INTEGER32;



(* ENUMERATED CLASS OF MARGIN LOCATIONS *)
(* enum marg_loc {top_marg, bottom_marg, left_marg, right_marg}; *)
CONST top_marg                 = 0;
CONST bottom_marg              = 1;
CONST left_marg                = 2;
CONST right_marg               = 3;
TYPE marg_loc                  = INTEGER32;



(* ENUMERATED CLASS OF WRAP PROPERTY TYPES *)
(* enum wrap_type {no_wrap, char_wrap, word_wrap}; *)
CONST no_wrap                  = 0;
CONST char_wrap                = 1;
CONST word_wrap                = 2;
TYPE wrap_type                 = INTEGER32;



(******************************************************************************
    Special initializer for users of TML with other languages
******************************************************************************)

PROCEDURE tml_init; OPTIONS(C_PARAM, EXTERN);



(******************************************************************************
    Generic function pointer
******************************************************************************)

    TYPE GEN_FUNCP = ^FUNCTION  : UNIV_PTR;



(******************************************************************************
    Structures used for general purposes with allocator and
    deallocator for each where necessary
******************************************************************************)


(* STRUCTURE USED TO CAPTURE CONTENTS OF A MEMBER OF CLASS MODEL_POS *)
(* DEFINED IN tml_c_structs.h *)

    (* allocate a C_MODEL_POS *)

TYPE PTR_TO_C_MODEL_POS        = ^C_MODEL_POS;

FUNCTION c_model_pos_alloc : PTR_TO_C_MODEL_POS; OPTIONS(C_PARAM, EXTERN);

    (* deallocate a C_MODEL_POS *)

PROCEDURE c_model_pos_free(
    VAR this_c_model_pos : C_MODEL_POS
    ); OPTIONS(C_PARAM, EXTERN);



(* STRUCTURE USED TO CAPTURE CONTENTS OF A MEMBER OF CLASS MODEL_RANGE *)
(* DEFINED IN tml_c_structs.h *)

    (* allocate a C_MODEL_RANGE *)

TYPE PTR_TO_C_MODEL_RANGE      = ^C_MODEL_RANGE;

FUNCTION c_model_range_alloc : PTR_TO_C_MODEL_RANGE; OPTIONS(C_PARAM, EXTERN);

    (* deallocate a C_MODEL_RANGE *)

PROCEDURE c_model_range_free(
    VAR this_c_model_range : C_MODEL_RANGE
    ); OPTIONS(C_PARAM, EXTERN);



(* STRUCTURE USED TO CAPTURE CONTENTS OF A MEMBER OF CLASS MARK_LIST *)
(* DEFINED IN tml_c_structs.h *)

    (* allocate a C_MARK_LIST *)

TYPE PTR_TO_C_MARK_LIST        = ^C_MARK_LIST;

FUNCTION c_mark_list_alloc : PTR_TO_C_MARK_LIST; OPTIONS(C_PARAM, EXTERN);

    (* deallocate a C_MARK_LIST *)

PROCEDURE c_mark_list_free(
    VAR this_c_mark_list : C_MARK_LIST
    ); OPTIONS(C_PARAM, EXTERN);



(* STRUCTURE USED TO CAPTURE CONTENTS OF A MEMBER OF CLASS XY_COORD *)
(* DEFINED IN tml_c_structs.h *)
 
    (* allocate a C_XY_COORD *)

TYPE PTR_TO_C_XY_COORD         = ^C_XY_COORD;

FUNCTION c_xy_coord_alloc : PTR_TO_C_XY_COORD; OPTIONS(C_PARAM, EXTERN);

    (* deallocate a C_XY_COORD *)

PROCEDURE c_xy_coord_free(
    VAR this_c_xy_coord : C_XY_COORD
    ); OPTIONS(C_PARAM, EXTERN);



(* STRUCTURE USED TO CAPTURE CONTENTS OF A MEMBER OF CLASS SCREEN_XY *)
(* DEFINED IN tml_c_structs.h *)

    (* UPPER LEFT CORNER OF A VIEWPORT *)

VAR zero_zero                  : EXTERN C_SCREEN_XY;

    (* allocate a C_SCREEN_XY *)

TYPE PTR_TO_C_SCREEN_XY        = ^C_SCREEN_XY;

FUNCTION c_screen_xy_alloc : PTR_TO_C_SCREEN_XY; OPTIONS(C_PARAM, EXTERN);

    (* deallocate a C_SCREEN_XY *)

PROCEDURE c_screen_xy_free(
    VAR this_c_screen_xy : C_SCREEN_XY
    ); OPTIONS(C_PARAM, EXTERN);



(* STRUCTURE USED TO SPECIFY PRINTING PARAMETERS *)
(* DEFINED IN tml_c_structs.h *)

    (* allocate a C_PRINT_DB *)

TYPE PTR_TO_C_PRINT_DB         = ^C_PRINT_DB;

FUNCTION c_print_db_alloc : PTR_TO_C_PRINT_DB; OPTIONS(C_PARAM, EXTERN);

    (* deallocate a C_PRINT_DB *)

PROCEDURE c_print_db_free(
    VAR this_c_print_db : C_PRINT_DB
    ); OPTIONS(C_PARAM, EXTERN);



(* STRUCTURE FOR CAPTURING THE CONTENTS OF A MEMBER OF CLASS SEARCH_ENV *)
(* DEFINED IN tml_c_structs.h *)

    (* allocate a C_SEARCH_ENV *)

TYPE PTR_TO_C_SEARCH_ENV       = ^C_SEARCH_ENV;

FUNCTION c_search_env_alloc : PTR_TO_C_SEARCH_ENV; OPTIONS(C_PARAM, EXTERN);

    (* deallocate a C_SEARCH_ENV *)

PROCEDURE c_search_env_free(
    VAR this_search_env : C_SEARCH_ENV
    ); OPTIONS(C_PARAM, EXTERN);




(******************************************************************************
    Objects used in the modelling component of tml

******************************************************************************)


(* CLASS MODEL_POS *)

    (* allocate a model_pos from free store *)

FUNCTION model_pos_class_alloc : PTR_TO_C_MODEL_POS; OPTIONS(C_PARAM, EXTERN);


    (* deallocate a model_pos *)

PROCEDURE model_pos_free(
    VAR this_model_pos : C_MODEL_POS
    ); OPTIONS(C_PARAM, EXTERN);


    (* return 1 if first position is same as second, 0 otherwise *)

FUNCTION model_pos_eq(
    VAR this_model_pos : C_MODEL_POS;
    VAR comp_pos : C_MODEL_POS
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* return 1 if first position is not the same as the second, 0 otherwise *)

FUNCTION model_pos_neq(
    VAR this_model_pos : C_MODEL_POS;
    VAR comp_pos : C_MODEL_POS
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* return 1 if first position is less than second, 0 otherwise *)

FUNCTION model_pos_lt(
    VAR this_model_pos : C_MODEL_POS;
    VAR comp_pos : C_MODEL_POS
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* return 1 if first position is less than or equal to second, *)
    (* 0 otherwise *)

FUNCTION model_pos_le(
    VAR this_model_pos : C_MODEL_POS;
    VAR comp_pos : C_MODEL_POS
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* return 1 if first position is greater than second, 0 otherwise *)

FUNCTION model_pos_gt(
    VAR this_model_pos : C_MODEL_POS;
    VAR comp_pos : C_MODEL_POS
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* return 1 if first position is greater than or equal to second, *)
    (* 0 otherwise *)

FUNCTION model_pos_ge(
    VAR this_model_pos : C_MODEL_POS;
    VAR comp_pos : C_MODEL_POS
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* second C_MODEL_POS* argument points to caller-supplied storage *)
    (* a pointer to the next formattable model position is written into the *)
    (* second argument. If all goes well, the return value equals the second *)
    (* argument. *)

FUNCTION model_pos_get_next(
    VAR this_model_pos : C_MODEL_POS;
    VAR next_pos : C_MODEL_POS
    ) : PTR_TO_C_MODEL_POS; OPTIONS(C_PARAM, EXTERN);


    (* second C_MODEL_POS* argument points to caller-supplied storage *)
    (* a pointer to the prior formattable model position is written into the *)
    (* second argument. If all goes well, the return value equals the second *)
    (* argument. *)

FUNCTION model_pos_get_prior(
    VAR this_model_pos : C_MODEL_POS;
    VAR prior_pos : C_MODEL_POS
    ) : PTR_TO_C_MODEL_POS; OPTIONS(C_PARAM, EXTERN);


    (* mark the page header associated with the argument model position *)
    (* as needing to be reformatted *)

PROCEDURE model_pos_mark_changed(
    VAR this_model_pos : C_MODEL_POS
    ); OPTIONS(C_PARAM, EXTERN);


    (* returns zero if the node at which the model position is set is not *)
    (* formattable or if the model position's node member is NULL. *)
    (* Otherwise, the nonzero return value depends on the node's type. *)

FUNCTION model_pos_can_format(
    VAR this_model_pos : C_MODEL_POS
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (*redraws every line on which the model pos occurs (if visible). Assumes *)
    (* that the change does not alter the format of the conceptual page*)

PROCEDURE model_pos_in_place_redraw(
    VAR this_model_pos : C_MODEL_POS
    ); OPTIONS(C_PARAM, EXTERN);




(* FOR CLASS MODEL_RANGE *)


    (* allocate a model_range from free store *)

FUNCTION model_range_class_alloc : PTR_TO_C_MODEL_RANGE; OPTIONS(C_PARAM, EXTERN);


    (* deallocate a model_range *)

PROCEDURE model_range_free(
    VAR model_range_p : C_MODEL_RANGE
    ); OPTIONS(C_PARAM, EXTERN);


    (* set the start member of the argument model_range to the model *)
    (* position specified by new_start *)

PROCEDURE model_range_set_start(
    VAR model_range_p : C_MODEL_RANGE;
    VAR new_start : C_MODEL_POS
    ); OPTIONS(C_PARAM, EXTERN);


    (* set the end member of the argument model_range to the model *)
    (* position specified by new_end *)

PROCEDURE model_range_set_end(
    VAR model_range_p : C_MODEL_RANGE;
    VAR new_end : C_MODEL_POS
    ); OPTIONS(C_PARAM, EXTERN);


    (* get the start member of a model range *)
    (* Second argument points to user-supplied storage. If all goes well, *)
    (* the return value equals the second argument. *)

FUNCTION model_range_get_start(
    VAR model_range_p : C_MODEL_RANGE;
    VAR model_pos_p : C_MODEL_POS
    ) : PTR_TO_C_MODEL_POS; OPTIONS(C_PARAM, EXTERN);


    (* get the end member of a model range *)
    (* Second argument points to user-supplied storage. If all goes well, *)
    (* the return value equals the second argument. *)

FUNCTION model_range_get_end(
    VAR model_range_p : C_MODEL_RANGE;
    VAR model_pos_p : C_MODEL_POS
    ) : PTR_TO_C_MODEL_POS; OPTIONS(C_PARAM, EXTERN);


    (* isolate the argument model_range into a subtree *)
    (* Return a pointer to the root of the subtree or NULL if the *)
    (* model_range is bogus *)

FUNCTION model_range_isolate(
    VAR model_range_p : C_MODEL_RANGE
    ) : UNIV_PTR; OPTIONS(C_PARAM, EXTERN);


    (* return 1 if the argument model_range contains target_pos, *)
    (* 0 otherwise. *)

FUNCTION model_range_contains(
    VAR model_range_p : C_MODEL_RANGE;
    VAR target_pos : C_MODEL_POS
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);




(* FOR CLASS NODE *)


    (* no allocator for class node is provided since class node is a *)
    (* container class. Use the allocator appropriate for the subclass *)
    (* desired. *)

    (* deallocate a node: dissociate it from its properties. If it is *)
    (* associated with a model, remove it from the model and make it the *)
    (* head of the free list for its subclass of node. *)

PROCEDURE node_free(
        this_node : tml_c_node
    ); OPTIONS(C_PARAM, EXTERN);



    (* FUNCTIONS ALLOWING INQUIRY AND SETTING OF THE DATA CONTAINED *)
    (* IN THE CLASS *)


    (* get model associated with tml_c_node node *)

FUNCTION node_get_model(
        this_node : tml_c_node
    ) : tml_c_model; OPTIONS(C_PARAM, EXTERN);


    (* set model member of tml_c_node to tml_c_model *)

PROCEDURE node_set_model(
        this_node : tml_c_node;
        new_model : tml_c_model
    ); OPTIONS(C_PARAM, EXTERN);


    (* get node type member of tml_c_node - one of enum node_type *)

FUNCTION node_get_type(
        this_node : tml_c_node
    ) : node_type; OPTIONS(C_PARAM, EXTERN);


    (* set node type member of tml_c_node to node_type specified by node_type *)

PROCEDURE node_set_type(
        this_node : tml_c_node;
        this_type : node_type
    ); OPTIONS(C_PARAM, EXTERN);


    (* find the level of tml_c_node in the tree by counting *)

FUNCTION node_get_level(
        this_node : tml_c_node
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* get the one-based sibling order (leftmost is 1) of tml_c_node *)

FUNCTION node_get_sib_order(
        this_node : tml_c_node
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* get the property vector associated with tml_c_node *)

FUNCTION node_get_props(
        this_node : tml_c_node
    ) : tml_c_prop_vec; OPTIONS(C_PARAM, EXTERN);


    (* get the model_range spanned by the subtree rooted at node *)

FUNCTION node_get_span(
        this_node : tml_c_node;
    VAR model_range_p : C_MODEL_RANGE
    ) : PTR_TO_C_MODEL_RANGE; OPTIONS(C_PARAM, EXTERN);



    (* FUNCTIONS FOR PLACING AND MOVING NODES IN A TREE *)


    (* connect 2nd node to 1st in direction specified - one of enum node_dir *)

FUNCTION node_connect_node(
        this_node : tml_c_node;
        to_connect : tml_c_node;
        dir : node_dir
    ) : tml_c_node; OPTIONS(C_PARAM, EXTERN);


    (* take a node out of a tree *)

PROCEDURE node_detach(
        this_node : tml_c_node
    ); OPTIONS(C_PARAM, EXTERN);


    (* move 1st node to place in direction specified from 2nd node *)

FUNCTION node_move(
        this_node : tml_c_node;
        move_to : tml_c_node;
        dir : node_dir
    ) : tml_c_node; OPTIONS(C_PARAM, EXTERN);



    (* FUNCTIONS DEALING WITH PROPERTIES OF NODES *)


    (* attach a property vector to a node *)

PROCEDURE node_prop_attach(
        this_node : tml_c_node;
        add_pvec : tml_c_prop_vec
    ); OPTIONS(C_PARAM, EXTERN);


    (* detach a node's property vector from it *)

PROCEDURE node_prop_detach(
        this_node : tml_c_node
    ); OPTIONS(C_PARAM, EXTERN);


    (* deactivate all the properties of a node *)

PROCEDURE node_exit_props(
        this_node : tml_c_node
    ); OPTIONS(C_PARAM, EXTERN);


    (* activate all the properties of a node *)

PROCEDURE node_enter_props(
        this_node : tml_c_node
    ); OPTIONS(C_PARAM, EXTERN);



    (* VIRTUAL FUNCTIONS--ACTUAL IMPLEMENTATION MAY DIFFER *)
    (* FOR VARIOUS SUB-CLASSES *)


    (* does this node contain formattable information? 1==yes, 0==no *)

FUNCTION node_can_format(
        this_node : tml_c_node
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* for text nodes (gnodes) give number of characters dominated *)

FUNCTION node_get_max_index(
        this_node : tml_c_node
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);



    (* THE FOLLOWING VIRTUAL FUNCTIONS ARE ILL-DEFINED *)
    (* FOR ALL BUT THE DERIVED CLASSES *)


    (* return pointer to formattable contents dominated by this node *)

FUNCTION node_get_contents(
        this_node : tml_c_node
    ) : UNIV_PTR; OPTIONS(C_PARAM, EXTERN);


    (* get new copy of node in model specified; if model is zero, *)
    (* use same model as node is associated with *)

FUNCTION node_copy(
        this_node : tml_c_node;
        to_model : tml_c_model
    ) : tml_c_node; OPTIONS(C_PARAM, EXTERN);


    (* copy the subtree below node to model specified; if model is zero, *)
    (* use same model as node is associated with *)

FUNCTION node_copy_all(
        this_node : tml_c_node;
        to_model : tml_c_model
    ) : tml_c_node; OPTIONS(C_PARAM, EXTERN);


    (* duplicate this node in its model; use same property vector as *)
    (* original node *)

FUNCTION node_dup(
        this_node : tml_c_node
    ) : tml_c_node; OPTIONS(C_PARAM, EXTERN);


    (* duplicate, as above, the subtree at node in its model *)

FUNCTION node_dup_all(
        this_node : tml_c_node
    ) : tml_c_node; OPTIONS(C_PARAM, EXTERN);


    (* split nodes for insertion; implementation varies with node type *)
    (* for gnode: split at text index specified by long; put portion to *)
    (* left of that index into one node; put portion starting at that *)
    (* index into another node; create an empty node; make these three *)
    (* nodes siblings in order left-empty-right. *)

FUNCTION node_split(
        this_node : tml_c_node;
        split_point : INTEGER32
    ) : tml_c_node; OPTIONS(C_PARAM, EXTERN);



    (* NAVIGATION FUNCTIONS *)


    (* get next node in traversal order; direction traveled from returned *)
    (* in node_dir* argument if returning from lower level *)

FUNCTION node_get_next(
        this_node : tml_c_node;
    VAR dir : node_dir
    ) : tml_c_node; OPTIONS(C_PARAM, EXTERN);


    (* get previous node in traversal order; direction traveled from returned *)
    (* in node_dir* argment if returning from lower level *)

FUNCTION node_get_prev(
        this_node : tml_c_node;
    VAR dir : node_dir
    ) : tml_c_node; OPTIONS(C_PARAM, EXTERN);


    (* get the node in the specified direction (one of node_dir) from *)
    (* node argument *)

FUNCTION node_get_node(
        this_node : tml_c_node;
        dir : node_dir
    ) : tml_c_node; OPTIONS(C_PARAM, EXTERN);


    (* make the first node's pointer in direction specified by node_dir*)
    (* (one of node_dir) point to second node *)

PROCEDURE node_set_node(
        this_node : tml_c_node;
        to_node : tml_c_node;
        dir : node_dir
    ); OPTIONS(C_PARAM, EXTERN);


    (* get deepest rightmost node in subtree which has this node as root *)
    (* or rightmost sibling of this node if this node is childless *)

FUNCTION node_get_last(
        this_node : tml_c_node
    ) : tml_c_node; OPTIONS(C_PARAM, EXTERN);



    (* FUNCTIONS MEANINGFUL ONLY FOR CERTAIN SUBCLASSES *)


    (* MEANINGFUL ONLY FOR GNODES AND OTHER TYPES HANDLING CHARACTER DATA *)


    (* associate data_count bytes of data at data_start with this_node. *)
    (* Returns 0 if applied to a nonterminal type of node, otherwise *)
    (* dissociates node from any data it currently dominates, and copies *)
    (* data at data_start into new data space. New data space is allocated *)
    (* from node's associated model if any, otherwise from free space. *)

FUNCTION node_attach_data(
        this_node : tml_c_node;
        data_start : UNIV_PTR;
        data_count : INTEGER32
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);

    (* insert add_count characters of add_data after character at *)
    (* after_index in goo associated with this_node. Returns model position *)
    (* of last character inserted. C_MODEL_POS argument points to *)
    (* user-supplied storage. *)

FUNCTION node_insert(
        this_node : tml_c_node;
        after_index : INTEGER32;
    VAR add_data_start : CHAR;
        add_count : INTEGER32;
    VAR model_pos_p : C_MODEL_POS
    ) : PTR_TO_C_MODEL_POS; OPTIONS(C_PARAM, EXTERN);

    (* delete delete_num characters at delete_index from goo associated with *)
    (* this_node. Return model position of node == 0 and char_index == -1. *)
    (* (Implementations of this function for appropriate subclasses can *)
    (* return a good model position.) *)
    (* C_MODEL_POS argument points to user-supplied storage. *)

FUNCTION node_del_cont(
        this_node : tml_c_node;
        delete_index : INTEGER32;
        delete_num : INTEGER32;
    VAR model_pos_p : C_MODEL_POS
    ) : PTR_TO_C_MODEL_POS; OPTIONS(C_PARAM, EXTERN);


    (* overstrike, with rep_with, over_num characters of goo associated with *)
    (* this_node, starting at begin_index. Returns model position of *)
    (* node == 0 and char_index == -1. *)
    (* (Implementations of this function for appropriate subclasses can *)
    (* return a good model position.) *)
    (* C_MODEL_POS argument points to user-supplied storage. *)

FUNCTION node_overstrike(
        this_node : tml_c_node;
        begin_index : INTEGER32;
    VAR rep_with_start : CHAR;
        over_num : INTEGER32;
    VAR model_pos_p : C_MODEL_POS
    ) : PTR_TO_C_MODEL_POS; OPTIONS(C_PARAM, EXTERN);



    (* FORMATTING FUNCTIONS *)


    (* get the height of the bounding box for information to be formatted *)
    (* out of this node *)

FUNCTION node_get_format_hi(
        this_node : tml_c_node;
        in_format : tml_c_format
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* return conceptual line associated with the given node under control *)
    (* of the given format. Formatting is to start at a point (e.g. *)
    (* character index) in the formattable information (e.g. text string) *)
    (* dominated by the node. This point is specified by the first long *)
    (* argument. The second and third long arguments give the height and *)
    (* width, respectively, of the space remaining on the current conceptual *)
    (* page. The final long argument indicates whether this is the first time *)
    (* this node has been formatted (i.e. whether formatting or reformatting *)
    (* is being performed.) *)

FUNCTION node_format_line(
        this_node : tml_c_node;
        in_format : tml_c_format;
        start_index : INTEGER32;
        space_hi : INTEGER32;
        space_wide : INTEGER32;
        first_concep_pixel : INTEGER32
    ) : tml_c_cline; OPTIONS(C_PARAM, EXTERN);


    (* like node_format_line, but it formats BACKWARD from the point specified. *)

FUNCTION node_tamrof_line(
        this_node : tml_c_node;
        in_format : tml_c_format;
        start_index : INTEGER32;
        space_hi : INTEGER32;
        space_wide : INTEGER32;
        first_concep_pixel : INTEGER32
    ) : tml_c_cline; OPTIONS(C_PARAM, EXTERN);




(* FOR CLASS BNODE *)

    (* -- DERIVED CLASS FOR NON-TERMINAL NODES IN THE MODEL STRUCTURE TREE *)


    (* allocate a bnode in the given model. If the argument is zero, *)
    (*   allocate from free space. *)

FUNCTION bnode_class_alloc(
        to_model : tml_c_model
    ) : tml_c_bnode; OPTIONS(C_PARAM, EXTERN);


    (* deallocate a bnode *)

PROCEDURE bnode_free(
        this_bnode : tml_c_bnode
    ); OPTIONS(C_PARAM, EXTERN);




(* FOR CLASS GNODE *)

    (* -- DERIVED CLASS FOR A TERMINAL OBJECT WHICH POINTS TO *)
    (* CHARACTERS IN THE GOO HEAP *)


    (* allocate a gnode in the given model. If the argument is zero, *)
    (*   allocate from free space. *)

FUNCTION gnode_class_alloc(
        to_model : tml_c_model
    ) : tml_c_gnode; OPTIONS(C_PARAM, EXTERN);


    (* deallocate a gnode *)

PROCEDURE gnode_free(
        this_gnode : tml_c_gnode
    ); OPTIONS(C_PARAM, EXTERN);


    (* after this call, the argument gnode dominates text equivalent to the *)
    (* null-terminated string specified by the argument char*. The gnode's *)
    (* copy doesn't include the null terminator *)

PROCEDURE gnode_gets(
        this_gnode : tml_c_gnode;
    VAR s_start : CHAR
    ); OPTIONS(C_PARAM, EXTERN);


    (* get the non-null-terminated string dominated by the node *)

FUNCTION gnode_get_contents(
        this_gnode : tml_c_gnode
    ) : UNIV_PTR; OPTIONS(C_PARAM, EXTERN);


    (* get the number of characters in the non-null-terminated string *)
    (* dominated by the node *)

FUNCTION gnode_get_char_count(
        this_gnode : tml_c_gnode
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* get a null-terminated copy of the string dominated by the node *)

FUNCTION gnode_get_0t_contents(
        this_gnode : tml_c_gnode
    ) : PTR_TO_CHAR; OPTIONS(C_PARAM, EXTERN);


    (* set the character count of a gnode *)

PROCEDURE gnode_set_char_count(
        gnode_p : tml_c_gnode;
        new_count : INTEGER32
    ); OPTIONS(C_PARAM, EXTERN);




(* FOR CLASS PROP_VEC *)


    (* allocate a property vector *)

FUNCTION prop_vec_class_alloc(
        to_model : tml_c_model
    ) : tml_c_prop_vec; OPTIONS(C_PARAM, EXTERN);


    (* deallocate a property vector *)

PROCEDURE prop_vec_free(
        this_prop_vec : tml_c_prop_vec
    ); OPTIONS(C_PARAM, EXTERN);


    (* return pointer to next member of argument property vector *)

FUNCTION prop_vec_get_next(
        this_prop_vec : tml_c_prop_vec
    ) : tml_c_prop_vec; OPTIONS(C_PARAM, EXTERN);


    (* detach 1st from 2nd *)

FUNCTION prop_vec_detach_pvec(
        this_prop_vec : tml_c_prop_vec;
        from_vec : tml_c_prop_vec
    ) : tml_c_prop_vec; OPTIONS(C_PARAM, EXTERN);


    (* prepend 2nd to 1st *)

FUNCTION prop_vec_prepend(
        this_prop_vec : tml_c_prop_vec;
        add_element : tml_c_prop_vec
    ) : tml_c_prop_vec; OPTIONS(C_PARAM, EXTERN);


    (* append 2nd to 1st *)

PROCEDURE prop_vec_append(
        this_prop_vec : tml_c_prop_vec;
        add_vec : tml_c_prop_vec
    ); OPTIONS(C_PARAM, EXTERN);


    (* copy the property vector to a model; if model is zero, use model *)
    (* that this property vector is associated with *)

FUNCTION prop_vec_copy(
        this_prop_vec : tml_c_prop_vec;
        to_model : tml_c_model
    ) : tml_c_prop_vec; OPTIONS(C_PARAM, EXTERN);


    (* copy this property vector and all property vectors chained to it *)
    (* through next pointers to a model. If model argument is zero, use *)
    (* model that this property vector is associated with *)

FUNCTION prop_vec_copy_all(
        this_prop_vec : tml_c_prop_vec;
        to_model : tml_c_model
    ) : tml_c_prop_vec; OPTIONS(C_PARAM, EXTERN);


    (* duplicate this property vector; i.e. copy it to the same model with *)
    (* the same member pointer values *)

FUNCTION prop_vec_dup(
        this_prop_vec : tml_c_prop_vec
    ) : tml_c_prop_vec; OPTIONS(C_PARAM, EXTERN);


    (* duplicate this property vector and all property vectors chained to it *)
    (* through next pointers *)

FUNCTION prop_vec_dup_all(
        this_prop_vec : tml_c_prop_vec
    ) : tml_c_prop_vec; OPTIONS(C_PARAM, EXTERN);


    (* attach property to prop_vec *)

PROCEDURE prop_vec_attach_prop(
        this_prop_vec : tml_c_prop_vec;
        add_prop : tml_c_property
    ); OPTIONS(C_PARAM, EXTERN);


    (* detach a prop_vec's property *)

PROCEDURE prop_vec_detach_prop(
        this_prop_vec : tml_c_prop_vec
    ); OPTIONS(C_PARAM, EXTERN);


    (* activate all properties associated with a property vector and the *)
    (* vectors chained to it *)

PROCEDURE prop_vec_activate(
        this_prop_vec : tml_c_prop_vec
    ); OPTIONS(C_PARAM, EXTERN);


    (* deactivate similarly *)

PROCEDURE prop_vec_deactivate(
        this_prop_vec : tml_c_prop_vec
    ); OPTIONS(C_PARAM, EXTERN);


    (* return the reference count associated with a property vector *)

FUNCTION prop_vec_get_ref_count(
        this_prop_vec : tml_c_prop_vec
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* return a pointer to the property associated with a given property *)
    (* vector *)

FUNCTION prop_vec_get_prop(
        this_prop_vec : tml_c_prop_vec
    ) : tml_c_property; OPTIONS(C_PARAM, EXTERN);




(* FOR CLASS PROPERTY *)


    (* allocate a property *)

FUNCTION property_class_alloc(
        to_model : tml_c_model
    ) : tml_c_property; OPTIONS(C_PARAM, EXTERN);


    (* deallocate a property *)

PROCEDURE property_free(
        this_property : tml_c_property
    ); OPTIONS(C_PARAM, EXTERN);


    (* get the index into the property function table of the function *)
    (* associated with instantiation of this property *)

FUNCTION property_get_index(
        this_property : tml_c_property
    ) : p_index; OPTIONS(C_PARAM, EXTERN);


    (* set the index member of the property to the integer argument's value *)

PROCEDURE property_set_index(
        this_property : tml_c_property;
        i : p_index
    ); OPTIONS(C_PARAM, EXTERN);


    (* copy a property to a model; if the model is zero, use the model this *)
    (* property is associated with *)

FUNCTION property_copy(
        this_property : tml_c_property;
        to_model : tml_c_model
    ) : tml_c_property; OPTIONS(C_PARAM, EXTERN);


    (* duplicate a property in the model with which it is associated *)

FUNCTION property_dup(
        this_property : tml_c_property
    ) : tml_c_property; OPTIONS(C_PARAM, EXTERN);


    (* return origin of entry argument vector for this property *)

FUNCTION property_get_entry_av(
        this_property : tml_c_property
    ) : tml_c_argument; OPTIONS(C_PARAM, EXTERN);


    (* return origin of exit argument vector for this property *)

FUNCTION property_get_exit_av(
        this_property : tml_c_property
    ) : tml_c_argument; OPTIONS(C_PARAM, EXTERN);


    (* attach a vector of entry arguments to a property *)

PROCEDURE property_attach_entry(
        this_property : tml_c_property;
        entry_vec : tml_c_argument
    ); OPTIONS(C_PARAM, EXTERN);


    (* attach a vector of exit argument to a property *)

PROCEDURE property_attach_exit(
        this_property : tml_c_property;
        exit_vec : tml_c_argument
    ); OPTIONS(C_PARAM, EXTERN);


    (* detach similarly *)

PROCEDURE property_detach_entry(
        this_property : tml_c_property
    ); OPTIONS(C_PARAM, EXTERN);


    (* detach similarly *)

PROCEDURE property_detach_exit(
        this_property : tml_c_property
    ); OPTIONS(C_PARAM, EXTERN);


    (* activate a property *)

PROCEDURE property_activate(
        this_property : tml_c_property
    ); OPTIONS(C_PARAM, EXTERN);


    (* deactivate similarly *)

PROCEDURE property_deactivate(
        this_property : tml_c_property
    ); OPTIONS(C_PARAM, EXTERN);


    (* return the reference count associated with the property *)

FUNCTION property_get_ref_count(
        this_property : tml_c_property
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);




(* FOR CLASS ARGUMENT *)


    (* allocate an argument *)

FUNCTION argument_class_alloc(
        to_model : tml_c_model
    ) : tml_c_argument; OPTIONS(C_PARAM, EXTERN);


    (* deallocate an argument *)

PROCEDURE argument_free(
        this_argument : tml_c_argument
    ); OPTIONS(C_PARAM, EXTERN);


    (* get the model associated with an argument *)

FUNCTION argument_get_model(
        this_argument : tml_c_argument
    ) : tml_c_model; OPTIONS(C_PARAM, EXTERN);


    (* set the value of an integer-valued argument *)

PROCEDURE argument_set_ival(
        this_argument : tml_c_argument;
        value : INTEGER32
    ); OPTIONS(C_PARAM, EXTERN);


    (* set the value of a floating-point argument - true doubles will have *)
    (* their fractional part truncated *)

PROCEDURE argument_set_fval(
        this_argument : tml_c_argument;
        value : DOUBLE
    ); OPTIONS(C_PARAM, EXTERN);


    (* set the value of a string argument to the non-null-terminated string *)
    (* at char* of val_count bytes length by copying the char* argument to *)
    (* space in a string heap *)

PROCEDURE argument_set_sval(
        this_argument : tml_c_argument;
    VAR value_start : CHAR;
        val_count : INTEGER32
    ); OPTIONS(C_PARAM, EXTERN);


    (* return a pointer to the "next" argument from this one *)

FUNCTION argument_get_next(
        this_argument : tml_c_argument
    ) : tml_c_argument; OPTIONS(C_PARAM, EXTERN);


    (* return the type of the argument - one of the enum arg_type *)

FUNCTION argument_get_vtype(
        this_argument : tml_c_argument
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* return the value of an integer argument *)

FUNCTION argument_get_ival(
        this_argument : tml_c_argument
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* return the value of a float argument *)

FUNCTION argument_get_fval(
        this_argument : tml_c_argument
    ) : DOUBLE; OPTIONS(C_PARAM, EXTERN);


    (* return the actual pointer to the non-null-terminated value of a *)
    (* string argument *)

FUNCTION argument_get_sval(
        this_argument : tml_c_argument
    ) : PTR_TO_CHAR; OPTIONS(C_PARAM, EXTERN);


    (* return the number of bytes in the above non-null-terminated string *)

FUNCTION argument_get_scount(
        this_argument : tml_c_argument
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* detach 1st from 2nd *)

FUNCTION argument_detach(
        this_argument : tml_c_argument;
        from_vec : tml_c_argument
    ) : tml_c_argument; OPTIONS(C_PARAM, EXTERN);


    (* append 2nd to 1st *)

PROCEDURE argument_append(
        this_argument : tml_c_argument;
        add_arg : tml_c_argument
    ); OPTIONS(C_PARAM, EXTERN);


    (* prepend 2nd to 1st *)

FUNCTION argument_prepend(
        this_argument : tml_c_argument;
        add_arg : tml_c_argument
    ) : tml_c_argument; OPTIONS(C_PARAM, EXTERN);


    (* return the reference count associated with an argument *)

FUNCTION argument_get_ref_count(
        this_argument : tml_c_argument
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* copy an argument to a model; if model is zero, use model this *)
    (* argument is in *)

FUNCTION argument_copy(
        this_argument : tml_c_argument;
        to_model : tml_c_model
    ) : tml_c_argument; OPTIONS(C_PARAM, EXTERN);


    (* copy an argument and all arguments chained to it through next *)
    (* pointers to a model *)
    (* if model is zero, use model this argument is in *)

FUNCTION argument_copy_all(
        this_argument : tml_c_argument;
        to_model : tml_c_model
    ) : tml_c_argument; OPTIONS(C_PARAM, EXTERN);





(* FOR CLASS HISTORY *)


    (* no allocator or deallocator included for class history *)

    (* set the size of the history array *)

FUNCTION history_set_hist_size(
        this_history : tml_c_history;
        size : INTEGER32
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* end the current molecule after the last operation performed *)

PROCEDURE history_end_molecule(
        this_history : tml_c_history
    ); OPTIONS(C_PARAM, EXTERN);


    (* undo the last molecule added to history *)

FUNCTION history_undo_molecule(
        this_history : tml_c_history
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* redo the last molecule added to history *)

FUNCTION history_redo_molecule(
        this_history : tml_c_history
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);



(* FOR CLASS MARK_LIST *)


    (* allocate a mark_list *)

FUNCTION mark_list_class_alloc : PTR_TO_C_MARK_LIST; OPTIONS(C_PARAM, EXTERN);


    (* deallocate a mark_list *)

PROCEDURE mark_list_free(
    VAR this_mark_list : C_MARK_LIST
    ); OPTIONS(C_PARAM, EXTERN);


    (* get the next member of the argument mark_list *)

FUNCTION mark_list_get_next(
    VAR mark_list_p : C_MARK_LIST
    ) : PTR_TO_C_MARK_LIST; OPTIONS(C_PARAM, EXTERN);


    (* get the prior member of the argument mark_list *)

FUNCTION mark_list_get_prior(
    VAR mark_list_p : C_MARK_LIST
    ) : PTR_TO_C_MARK_LIST; OPTIONS(C_PARAM, EXTERN);


    (* get the range member the argument mark_list *)

FUNCTION mark_list_get_range(
    VAR mark_list_p : C_MARK_LIST
    ) : PTR_TO_C_MODEL_RANGE; OPTIONS(C_PARAM, EXTERN);


    (* set the next member of the argument mark_list *)

PROCEDURE mark_list_set_next(
    VAR mark_list_p : C_MARK_LIST;
    VAR next_ml : C_MARK_LIST
    ); OPTIONS(C_PARAM, EXTERN);


    (* set the prior member of the argument mark_list *)

PROCEDURE mark_list_set_prior(
    VAR mark_list_p : C_MARK_LIST;
    VAR prior_ml : C_MARK_LIST
    ); OPTIONS(C_PARAM, EXTERN);


    (* set the range member of the argument mark_list *)

PROCEDURE mark_list_set_range(
    VAR mark_list_p : C_MARK_LIST;
    VAR new_range : C_MODEL_RANGE
    ); OPTIONS(C_PARAM, EXTERN);


    (* extend/shrink the range denominated by this mark_list *)

FUNCTION mark_list_extend_mark(
    VAR mark_list_p : C_MARK_LIST;
    VAR new_start : C_MODEL_POS;
    VAR new_end : C_MODEL_POS
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);

         
    (* highlight the text located by the mark_list *)

FUNCTION mark_list_draw(
    VAR mark_list_p : C_MARK_LIST
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* dehighlight the text located by the mark_list *)

FUNCTION mark_list_erase(
    VAR mark_list_p : C_MARK_LIST
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);



(* FOR CLASS SEARCH_ENV *)


    (* allocate a search_env *)

FUNCTION search_env_class_alloc(
        use_func : C_SEARCH_FUNC;
        use_compile : C_COMPILE_FUNC;
        use_for_next : C_SEARCH_NAV_FUNC;
        use_for_prior : C_SEARCH_NAV_FUNC;
        use_for_this : C_SEARCH_NAV_FUNC
    ) : PTR_TO_C_SEARCH_ENV; OPTIONS(C_PARAM, EXTERN);


    (* deallocate a search_env *)

PROCEDURE search_env_free(
    VAR this_search_env : C_SEARCH_ENV
    ); OPTIONS(C_PARAM, EXTERN);


    (* get the next member of the argument search_env *)

FUNCTION search_env_get_next(
    VAR search_env_p : C_SEARCH_ENV
    ) : PTR_TO_C_SEARCH_ENV; OPTIONS(C_PARAM, EXTERN);


    (* set the next member of the argument search_env *)

PROCEDURE search_env_set_next(
    VAR search_env_p : C_SEARCH_ENV;
    VAR new_next : C_SEARCH_ENV
    ); OPTIONS(C_PARAM, EXTERN);

   


(* FOR CLASS MODEL *)


    (* allocate a model *)

FUNCTION model_class_alloc : tml_c_model; OPTIONS(C_PARAM, EXTERN);


    (* deallocate a model *)

PROCEDURE model_free(
        this_model : tml_c_model
    ); OPTIONS(C_PARAM, EXTERN);



    (* INQUIRY FUNCTIONS FOR THE MODEL DATA *)


    (* get the root node of the model *)

FUNCTION model_get_root(
        this_model : tml_c_model
    ) : tml_c_node; OPTIONS(C_PARAM, EXTERN);


    (* get the point up to which properties are instantiated for the model *)

FUNCTION model_get_prop_pos(
        this_model : tml_c_model
    ) : tml_c_node; OPTIONS(C_PARAM, EXTERN);



    (* FUNCTIONS TO DIRECTLY MANIPULATE THE MODEL DATA *)


    (* make a root for a new model *)

FUNCTION model_make_root(
        this_model : tml_c_model
    ) : tml_c_node; OPTIONS(C_PARAM, EXTERN);


    (* set the root of a model to a given node *)

FUNCTION model_set_root(
        this_model : tml_c_model;
        new_root : tml_c_node
    ) : tml_c_node; OPTIONS(C_PARAM, EXTERN);


    (* inquire the state of the property associated with the p_index argument *)

FUNCTION model_inq_state(
        this_model : tml_c_model;
        prop_ind : p_index
    ) : UNIV_PTR; OPTIONS(C_PARAM, EXTERN);


    (* inquire the state of the property associated with the p_index argument *)
    (* at a certain node *)

FUNCTION model_inq_state_at_node(
        this_model : tml_c_model;
        at_node : tml_c_node;
        prop_ind : p_index
    ) : UNIV_PTR; OPTIONS(C_PARAM, EXTERN);


    (* move the current property position to the specified node, setting *)
    (* properties as needed *)

FUNCTION model_move_prop(
        this_model : tml_c_model;
        to_node : tml_c_node
    ) : tml_c_node; OPTIONS(C_PARAM, EXTERN);


    (* set the current property position at the specified node *)

PROCEDURE model_set_prop_pos(
        this_model : tml_c_model;
        new_prop_pos : tml_c_node
    ); OPTIONS(C_PARAM, EXTERN);



    (* FUNCTIONS WHICH ALLOCATE SPACE IN A MODEL *)


    (* allocate a property vector in the model *)

FUNCTION model_make_pvec(
        this_model : tml_c_model
    ) : tml_c_prop_vec; OPTIONS(C_PARAM, EXTERN);


    (* allocate a property in the model *)

FUNCTION model_make_prop(
        this_model : tml_c_model
    ) : tml_c_property; OPTIONS(C_PARAM, EXTERN);


    (* allocate an integer argument in the model *)

FUNCTION model_make_int_arg(
        this_model : tml_c_model;
        new_value : INTEGER32
    ) : tml_c_argument; OPTIONS(C_PARAM, EXTERN);


    (* allocate a float argument in the model. NOTE - full doubles will *)
    (* have their fractional parts truncated. *)

FUNCTION model_make_float_arg(
        this_model : tml_c_model;
        new_value : DOUBLE
    ) : tml_c_argument; OPTIONS(C_PARAM, EXTERN);


    (* allocate a string argument in the model *)

FUNCTION model_make_string_arg(
        this_model : tml_c_model;
    VAR new_value_start : CHAR;
        new_count : INTEGER32
    ) : tml_c_argument; OPTIONS(C_PARAM, EXTERN);


    (* allocate text characters in a model *)

FUNCTION model_make_goo(
        this_model : tml_c_model;
        count : INTEGER32;
    VAR contents_start : CHAR
    ) : PTR_TO_CHAR; OPTIONS(C_PARAM, EXTERN);


    (* make an object of the specified size in the model *)
    (* - for object type extensions *)

FUNCTION model_make_obj(
        this_model : tml_c_model;
        obj_size : INTEGER32
    ) : PTR_TO_CHAR; OPTIONS(C_PARAM, EXTERN);


    (* write a model to the file indicated by the argument pathname *)
    (* and pathname length. Return bytes written or -1 for failure. *)

FUNCTION model_d_write_model_path(
        this_model : tml_c_model;
    VAR pathname_start : CHAR;
        name_len : INTEGER32
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* write a model to the file indicated by the argument file handle. *)
    (* Returns bytes written or -1 for failure. *)

FUNCTION model_d_write_model_handle(
        this_model : tml_c_model;
        file_handle : UNIV_PTR
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* get a pointer to the history for the model *)

FUNCTION model_get_past(
        this_model : tml_c_model
    ) : tml_c_history; OPTIONS(C_PARAM, EXTERN);


    (* cut the subtree rooted at node from the model *)

FUNCTION model_cut(
        this_model : tml_c_model;
        cut_node : tml_c_node
    ) : UNIV_PTR; OPTIONS(C_PARAM, EXTERN);


    (* paste the subtree rooted at node into the model, attaching *)
    (* paste_node to past_to in direction paste_dir *)

FUNCTION model_paste(
        this_model : tml_c_model;
        paste_node : tml_c_node;
        paste_to : tml_c_node;
        paste_dir : node_dir
    ) : UNIV_PTR; OPTIONS(C_PARAM, EXTERN);


    (* get the first mark_list associated with the model *)

FUNCTION model_get_first_mark(
        this_model : tml_c_model
    ) : PTR_TO_C_MARK_LIST; OPTIONS(C_PARAM, EXTERN);


    (* allocate a mark_list in the model; initialize it to makr *)
    (* the text indicated by init_range *)

FUNCTION model_make_mark(
        this_model : tml_c_model;
    VAR init_range : C_MODEL_RANGE
    ) : PTR_TO_C_MARK_LIST; OPTIONS(C_PARAM, EXTERN);


    (* disassociate the argument mark_list from the model *)

PROCEDURE model_delete_mark(
        this_model : tml_c_model;
    VAR to_delete : C_MARK_LIST
    ); OPTIONS(C_PARAM, EXTERN);


    (* highlight the text located by the mark_list in any viewports *)
    (* that are attached to the model *)

FUNCTION model_mark_draw(
        this_model : tml_c_model;
    VAR to_draw : C_MARK_LIST
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* dehighlight the text located by the mark_list in any viewports *)
    (* that are attached to the model *)

FUNCTION model_mark_erase(
        this_model : tml_c_model;
    VAR to_erase : C_MARK_LIST
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* push the argument search_env onto the stack associated with the model *)

PROCEDURE model_push_search_env(
    VAR this_model : tml_c_model;
    VAR new_envir : C_SEARCH_ENV
    ); OPTIONS(C_PARAM, EXTERN);


    (* pop the top search_env from the stack associated with the model *)

PROCEDURE model_pop_search_env(
    VAR this_model : tml_c_model
    ); OPTIONS(C_PARAM, EXTERN);


    (* search for the regular expression indicated by pattern *)
    (* within the range indicated by the model_range argument *)

FUNCTION model_search_exp(
        this_model : tml_c_model;
        pattern : UNIV_PTR;
    VAR search_range : C_MODEL_RANGE;
        forward : INTEGER32;
    VAR model_range_p : C_MODEL_RANGE
    ) : PTR_TO_C_MODEL_RANGE; OPTIONS(C_PARAM, EXTERN);


    (* compile search_exp of length search_exp_len into a compiled regular *)
    (* expression of maximum lenght max_comp_len. Case sensitivity is a *)
    (* switch: 1 for case sensitive, 0 for not case sensitive *)

FUNCTION model_compile_exp(
        this_model : tml_c_model;
    VAR search_exp_start : CHAR;
        search_exp_len : INTEGER32;
        compiled_exp : UNIV_PTR;
        max_comp_len : INTEGER32;
        case_sens : INTEGER32
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* search for the string of length search_exp_len within the *)
    (* model_range specified *)

FUNCTION model_search(
        this_model : tml_c_model;
    VAR search_exp_start : CHAR;
        search_exp_len : INTEGER32;
    VAR search_range : C_MODEL_RANGE;
        forward : INTEGER32;
        case_sens : INTEGER32;
    VAR model_range_p : C_MODEL_RANGE
    ) : PTR_TO_C_MODEL_RANGE; OPTIONS(C_PARAM, EXTERN);
                                                                                                     

    (* updates, in a crude fashion, the display of the model when that model *)
    (* has been changed*)

PROCEDURE model_update_display(
        this_model : tml_c_model
    ); OPTIONS(C_PARAM, EXTERN);




(* FOR CLASS DRAW_MARK *)


    (* allocate a draw_mark *)

FUNCTION draw_mark_alloc : tml_c_draw_mark; OPTIONS(C_PARAM, EXTERN);


    (* deallocate a draw_mark *)

PROCEDURE draw_mark_free(
        this_draw_mark : tml_c_draw_mark
    ); OPTIONS(C_PARAM, EXTERN);


    (* return the next member of a draw_mark *)

FUNCTION draw_mark_get_next(
        this_draw_mark : tml_c_draw_mark
    ) : tml_c_draw_mark; OPTIONS(C_PARAM, EXTERN);


    (* return the prior member of a draw_port *)

FUNCTION draw_mark_get_prior(
        this_draw_mark : tml_c_draw_mark
    ) : tml_c_draw_mark; OPTIONS(C_PARAM, EXTERN);


    (* return the mark_list associated with this draw_list *)

FUNCTION draw_mark_get_model_mark(
        this_draw_mark : tml_c_draw_mark
    ) : tml_c_draw_mark; OPTIONS(C_PARAM, EXTERN);


    (* set the core drawing function for the draw mark *)

PROCEDURE draw_mark_set_core_func(
        this_draw_mark : tml_c_draw_mark;
        new_core : C_CORE_M_DRAW
    ); OPTIONS(C_PARAM, EXTERN);


    (* set the draw function for the draw mark *)

PROCEDURE draw_mark_set_draw_func(
        this_draw_mark : tml_c_draw_mark;
        new_draw : C_DRAW_M_DRAW
    ); OPTIONS(C_PARAM, EXTERN);


    (* extend/shrink the area indicated by the draw_mark *)

PROCEDURE draw_mark_extend(
        this_draw_mark : tml_c_draw_mark;
    VAR new_start : C_MODEL_POS;
    VAR new_end : C_MODEL_POS
    ); OPTIONS(C_PARAM, EXTERN);


    (* highlight the viewport area associated with the draw_mark *)

PROCEDURE draw_mark_draw(
        this_draw_mark : tml_c_draw_mark
    ); OPTIONS(C_PARAM, EXTERN);


    (* dehighlight the viewport area associated with the draw_mark *)

PROCEDURE draw_mark_erase(
        this_draw_mark : tml_c_draw_mark
    ); OPTIONS(C_PARAM, EXTERN);




(* FOR CLASS PROP_FUNC_ENT *)


    (* allocate a property function entry *)

FUNCTION tml_c_prop_func_ent_class_alloc : tml_c_prop_func_ent; OPTIONS(C_PARAM, EXTERN);


    (* deallocate a property function entry *)

PROCEDURE tml_c_prop_func_ent_free(
        this_prop_func_ent : tml_c_prop_func_ent
    ); OPTIONS(C_PARAM, EXTERN);


    (* set 1st's next to 2nd *)

PROCEDURE prop_func_ent_set_next(
        this_prop_func_ent : tml_c_prop_func_ent;
        next_ent : tml_c_prop_func_ent
    ); OPTIONS(C_PARAM, EXTERN);


    (* set the index member to the argument p_index; this is a *)
    (* property index *)

PROCEDURE prop_func_ent_set_index(
        this_prop_func_ent : tml_c_prop_func_ent;
        i : p_index
    ); OPTIONS(C_PARAM, EXTERN);


    (* get that index member *)

FUNCTION prop_func_ent_get_index(
        this_prop_func_ent : tml_c_prop_func_ent
    ) : p_index; OPTIONS(C_PARAM, EXTERN);


    (* set the pointer to the function that enters this property *)

PROCEDURE prop_func_ent_load_entry(
        this_prop_func_ent : tml_c_prop_func_ent;
        new_entry : C_PROP_FUNC_PT
    ); OPTIONS(C_PARAM, EXTERN);


    (* set the pointer to the function that exits this property *)

PROCEDURE prop_func_ent_load_exit(
        this_prop_func_ent : tml_c_prop_func_ent;
        new_exit : C_PROP_FUNC_PT
    ); OPTIONS(C_PARAM, EXTERN);


    (* get that entry function pointer *)

FUNCTION prop_func_ent_get_entry(
        this_prop_func_ent : tml_c_prop_func_ent
    ) : C_PROP_FUNC_PT; OPTIONS(C_PARAM, EXTERN);


    (* get that exit function pointer *)

FUNCTION prop_func_ent_get_exit(
        this_prop_func_ent : tml_c_prop_func_ent
    ) : C_PROP_FUNC_PT; OPTIONS(C_PARAM, EXTERN);


    (* get load status of the prop_func_ent *)

FUNCTION prop_func_ent_get_loaded(
        this_prop_func_ent : tml_c_prop_func_ent
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* set load status to the argument integer (will be truncated to a short) *)

PROCEDURE prop_func_ent_set_loaded(
        this_prop_func_ent : tml_c_prop_func_ent;
        i : INTEGER32
    ); OPTIONS(C_PARAM, EXTERN);


    (* load the function associated with a property into the property *)
    (* function table *)

PROCEDURE prop_func_ent_load(
        this_prop_func_ent : tml_c_prop_func_ent
    ); OPTIONS(C_PARAM, EXTERN);





(**********************************************************************************
    Objects used in the formatting component of tml

**********************************************************************************)



(* FOR CLASS CLINE *)


    (* no allocator supplied for class cline since it is a container class. *)
    (* Use the allocator for the subclass desired. *)


    (* deallocate a cline *)

PROCEDURE cline_free(
        this_cline : tml_c_cline
    ); OPTIONS(C_PARAM, EXTERN);


    (* get the type of this conceptual line (one of enum cl_type) *)

FUNCTION cline_get_type(
        this_cline : tml_c_cline
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* get the x position of the upper left corner of bounding box of this *)
    (* conceptual line *)

FUNCTION cline_get_ulx(
        this_cline : tml_c_cline
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* get the y position of the upper left corner of bounding box of this *)
    (* conceptual line *)

FUNCTION cline_get_uly(
        this_cline : tml_c_cline
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* get the x position of the lower left corner of bounding box of this *)
    (* conceptual line *)

FUNCTION cline_get_lrx(
        this_cline : tml_c_cline
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* get the y position of the lower left corner of bounding box of this *)
    (* conceptual line *)

FUNCTION cline_get_lry(
        this_cline : tml_c_cline
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* get the height in pixels of this conceptual line *)

FUNCTION cline_get_hi(
        this_cline : tml_c_cline
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* get the width in pixels of this conceptual line *)

FUNCTION cline_get_wide(
        this_cline : tml_c_cline
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* get the page header associated with this conceptual line *)

FUNCTION cline_get_phead(
        this_cline : tml_c_cline
    ) : tml_c_phead; OPTIONS(C_PARAM, EXTERN);


    (* get the format associated with this conceptual line *)

FUNCTION cline_get_format(
        this_cline : tml_c_cline
    ) : tml_c_format; OPTIONS(C_PARAM, EXTERN);


    (* gets the next conceptual line as a tml_c_cline (not virtual) *)

FUNCTION cline_inq_next(
        this_cline : tml_c_cline
    ) : tml_c_cline; OPTIONS(C_PARAM, EXTERN);


    (* gets the prior conceptual line as a tml_c_cline (not virtual) *)

FUNCTION cline_inq_prior(
        this_cline : tml_c_cline
    ) : tml_c_cline; OPTIONS(C_PARAM, EXTERN);


    (* gets the conceptual line below the current conceptual line *)
    (* (not virtual) *)

FUNCTION cline_get_down(
        this_cline : tml_c_cline
    ) : tml_c_cline; OPTIONS(C_PARAM, EXTERN);


    (* gets the conceptual line above the current conceptual line *)
    (* (not virtual) *)

FUNCTION cline_get_up(
        this_cline : tml_c_cline
    ) : tml_c_cline; OPTIONS(C_PARAM, EXTERN);



    (* TRAITS TO MANIPULATE CONCEPTUAL LINE DATA *)


    (* set the page header member of the conceptual line *)

PROCEDURE cline_set_phead(
        this_cline : tml_c_cline;
        on_page : tml_c_phead
    ); OPTIONS(C_PARAM, EXTERN);


    (* set the type of the conceptual line to the long argument *)
    (* (one of enum cl_type) *)

PROCEDURE cline_set_type(
        this_cline : tml_c_cline;
        new_type : INTEGER32
    ); OPTIONS(C_PARAM, EXTERN);


    (* set the upper left corner coordinates of the bounding box of this *)
    (* conceptual line. The first long argument is the x value in pixels; *)
    (* the second is the y value. Arguments upper_x and upper_y will be *)
    (* truncated to shorts *)

PROCEDURE cline_set_ul_coord(
        this_cline : tml_c_cline;
        upper_x : INTEGER32;
        upper_y : INTEGER32
    ); OPTIONS(C_PARAM, EXTERN);


    (* set the width member of the conceptual line to the number of pixels *)
    (* specified by the long argument, which will be truncated to a short *)

PROCEDURE cline_set_wide(
        this_cline : tml_c_cline;
        set_wide : INTEGER32
    ); OPTIONS(C_PARAM, EXTERN);


    (* set the height member of the conceptual line to the number of pixels *)
    (* specified by the long argument, which will be truncated to a short *)

PROCEDURE cline_set_hi(
        this_cline : tml_c_cline;
        new_hi : INTEGER32
    ); OPTIONS(C_PARAM, EXTERN);



    (* TRAITS TO DO THINGS TO A CONCEPTUAL LINE *)


    (* splits a free conceptual line in two either horizontally or *)
    (* vertically. Vertical splits have a direction of 0; direction values *)
    (* greater than zero indicate a horizontal split. If from_top = 0, *)
    (* the split will create a new cline of new_size depth (width) *)
    (* from the top (left) of the indicated cline. Otherwise the split *)
    (* will create a new cline of new_size depth (width) from the *)
    (* bottom (right) of the indicated cline. Integer arguments will be *)
    (* truncated to shorts. *)

FUNCTION cline_split(
        this_cline : tml_c_cline;
        new_size : INTEGER32;
        from_top : INTEGER32;
        direction : INTEGER32
    ) : tml_c_cline; OPTIONS(C_PARAM, EXTERN);


    (* resizes the height of a conceptual line and all lines below the *)
    (* adjusted line to current height plus the long argument (pixels) *)
    (* which will be truncated to a short *)

FUNCTION cline_resize(
        this_cline : tml_c_cline;
        hi_delta : INTEGER32
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* attach a line before (long before != 0) or after (long before == 0) *)
    (* this line-- needs to update the coordinates of the lines below *)

PROCEDURE cline_attach(
        this_cline : tml_c_cline;
        target_line : tml_c_cline;
        before : INTEGER32
    ); OPTIONS(C_PARAM, EXTERN);


    (* detach a line from a conceptual page--needs to update the coordinates *)
    (* of the lines below *)

PROCEDURE cline_detach(
        this_cline : tml_c_cline
    ); OPTIONS(C_PARAM, EXTERN);



    (* VIRTUAL FUNCTIONS FOR THIS CLASS *)


    (* get the next conceptual line (virtual) *)

FUNCTION cline_get_next(
        this_cline : tml_c_cline
    ) : tml_c_cline; OPTIONS(C_PARAM, EXTERN);


    (* set the next pointer of the first argument to the second *)

PROCEDURE cline_set_next(
        this_cline : tml_c_cline;
        next_line : tml_c_cline
    ); OPTIONS(C_PARAM, EXTERN);


    (* get the prior conceptual line (virtual) *)

FUNCTION cline_get_prior(
        this_cline : tml_c_cline
    ) : tml_c_cline; OPTIONS(C_PARAM, EXTERN);


    (* set the prior pointer of the first argument to the second *)

PROCEDURE cline_set_prior(
        this_cline : tml_c_cline;
        prior_line : tml_c_cline
    ); OPTIONS(C_PARAM, EXTERN);


    (* C_MODEL_POS* argument points to caller-supplied storage; *)
    (* the model position at the start of the conceptual line is copied *)
    (* into it. If all goes well, the return value equals the second *)
    (* argument. *)

FUNCTION cline_get_start(
        this_cline : tml_c_cline;
    VAR model_pos_p : C_MODEL_POS
    ) : PTR_TO_C_MODEL_POS; OPTIONS(C_PARAM, EXTERN);


    (* C_MODEL_POS* argument points to caller-supplied storage; *)
    (* the model position at the end of the conceptual line is copied *)
    (* into it. If all goes well, the return value equals the second *)
    (* argument. *)

FUNCTION cline_get_end(
        this_cline : tml_c_cline;
    VAR model_pos_p : C_MODEL_POS
    ) : PTR_TO_C_MODEL_POS; OPTIONS(C_PARAM, EXTERN);


    (* get the starting x offset from first pixel of first character in line *)

FUNCTION cline_get_start_x_off(
        this_cline : tml_c_cline
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* replace the line represented by the second argument with the line *)
    (* represented by by the first argument *)

PROCEDURE cline_replace(
        this_cline : tml_c_cline;
        replace_line : tml_c_cline
    ); OPTIONS(C_PARAM, EXTERN);


    (* release the cline argument (delete it) *)

PROCEDURE cline_release(
        this_cline : tml_c_cline
    ); OPTIONS(C_PARAM, EXTERN);


    (* allocate some space from this line and link in the line supplied *)
    (* (fill_with). If this is not free space, return 0. Otherwise, return *)
    (* the free line closest to this left after the allocation. If long *)
    (* argument at_bottom = 0, put fill_with at the top (left) of this line, *)
    (* else put fill_width at the bottom (left) of the line *)

FUNCTION cline_alloc_space(
        this_cline : tml_c_cline;
        fill_with : tml_c_cline;
        at_bottom : INTEGER32
    ) : tml_c_cline; OPTIONS(C_PARAM, EXTERN);


    (* C_XY_COORD* argument points to caller-supplied storage *)
    (* The xy coordinates of the indicated model position are copied *)
    (* into the C_XY_COORD* argument. If all goes well, the return value *)
    (* equals the third argument *)

FUNCTION cline_mpos_2_xy(
        this_cline : tml_c_cline;
    VAR find_pos : C_MODEL_POS;
    VAR new_xy_coord : C_XY_COORD
    ) : PTR_TO_C_XY_COORD; OPTIONS(C_PARAM, EXTERN);


    (* C_MODEL_POS* argument points to caller-supplied storage *)
    (* The model position associated with the C_XY_COORD* argument is copied *)
    (* into the C_MODEL_POS* argument. If all goes well, the return value *)
    (* equals the third argument. *)

FUNCTION cline_xy_2_mpos(
        this_cline : tml_c_cline;
    VAR where : C_XY_COORD;
    VAR new_model_pos : C_MODEL_POS
    ) : PTR_TO_C_MODEL_POS; OPTIONS(C_PARAM, EXTERN);


    (* draw the area for the cline at the xy position indicated by the third *)
    (* argument. Return a view_pos if the area is not free, zero otherwise. *)

FUNCTION cline_draw_line(
        this_cline : tml_c_cline;
        in_viewport : tml_c_view_port;
    VAR where : C_SCREEN_XY;
        start_index : INTEGER32
    ) : tml_c_view_pos; OPTIONS(C_PARAM, EXTERN);


    (* reformat the line - always called on a derived class object of class *)
    (* cline (e.g. tline) *)

FUNCTION cline_reformat(
        this_cline : tml_c_cline;
    VAR new_start : C_MODEL_POS;
    VAR next_ok : INTEGER32;
        force_start : INTEGER32
    ) : tml_c_cline; OPTIONS(C_PARAM, EXTERN);




(* FOR CLASS TLINE *)


    (* allocate a tline; if tml_c_format is nonzero, set the tline's *)
    (* format to that value *)

FUNCTION tline_class_alloc(
        this_tline : tml_c_tline;
        this_format : tml_c_format
    ) : tml_c_tline; OPTIONS(C_PARAM, EXTERN);

    (* deallocate a tline *)

PROCEDURE tline_free(
        this_tline : tml_c_tline
    ); OPTIONS(C_PARAM, EXTERN);



    (* TRAITS TO ACCESS THE TEXT LINE DATA *)


    (* get the tline to the right of this tline *)

FUNCTION tline_get_right(
        this_tline : tml_c_tline
    ) : tml_c_cline; OPTIONS(C_PARAM, EXTERN);


    (* get the tline to the left of this tline *)

FUNCTION tline_get_left(
        this_tline : tml_c_tline
    ) : tml_c_cline; OPTIONS(C_PARAM, EXTERN);


    (* get the font associated with this tline *)

FUNCTION tline_get_font(
        this_tline : tml_c_tline
    ) : tml_c_font_tbl; OPTIONS(C_PARAM, EXTERN);


    (* get the galley depth (in pixels) at which the baseline *)
    (* of this tline is located *)

FUNCTION tline_get_baseline(
        this_tline : tml_c_tline
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* return the number of characters set on this tline *)

FUNCTION tline_get_count(
        this_tline : tml_c_tline
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);



    (* TRAITS TO MANIPULATE THE TEXT LINE DATA *)


    (* adjust the baseline for this tline, and all baselines to its right *)
    (* (all its right siblings) to the new baseline *)

FUNCTION tline_adjust_baseline(
        this_tline : tml_c_tline;
        new_baseline_y : INTEGER32
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* set the galley depth (in pixels) at which the baseline of this tline *)
    (* is to be located *)

PROCEDURE tline_set_baseline(
        this_tline : tml_c_tline;
        new_baseline : INTEGER32
    ); OPTIONS(C_PARAM, EXTERN);


    (* set the font to be associated with this tline *)

PROCEDURE tline_set_font(
        this_tline : tml_c_tline;
        new_font : tml_c_font_tbl
    ); OPTIONS(C_PARAM, EXTERN);


    (* set the model position at which this tline begins *)

PROCEDURE tline_set_start(
        this_tline : tml_c_tline;
    VAR new_start : C_MODEL_POS
    ); OPTIONS(C_PARAM, EXTERN);


    (* set the number of characters to be formatted on this tline *)

PROCEDURE tline_set_count(
        this_tline : tml_c_tline;
        new_count : INTEGER32
    ); OPTIONS(C_PARAM, EXTERN);


    (* set the width (in pixels) of the formatted text on this tline *)

PROCEDURE tline_set_text_width(
        this_tline : tml_c_tline;
        new_width : INTEGER32
    ); OPTIONS(C_PARAM, EXTERN);


    (* return width of text contained by tml_c_tline argument *)

FUNCTION tline_get_text_width(
        this_tline : tml_c_tline
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* return width of text contained by tml_c_tline argument and all of *)
    (* its right siblings *)

FUNCTION tline_get_full_text_width(
        this_tline : tml_c_tline
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* set the right member of this tline *)

PROCEDURE tline_set_right(
        this_tline : tml_c_tline;
        new_right : tml_c_tline
    ); OPTIONS(C_PARAM, EXTERN);


    (* set the left member of this tline *)

PROCEDURE tline_set_left(
        this_tline : tml_c_tline;
        new_left : tml_c_tline
    ); OPTIONS(C_PARAM, EXTERN);




(* FOR CLASS PHEAD *)


    (* allocate a page header. If format is nonzero, set the *)
    (* phead's format to that value *)

FUNCTION phead_class_alloc(
        to_format : tml_c_format
    ) : tml_c_phead; OPTIONS(C_PARAM, EXTERN);


    (* deallocate a phead *)

PROCEDURE phead_free(
        this_phead : tml_c_phead
    ); OPTIONS(C_PARAM, EXTERN);



    (* TRAITS ALLOWING ACCESS TO THE PHEAD DATA FIELDS *)


    (* get the page header of the following page *)

FUNCTION phead_get_next(
        this_phead : tml_c_phead
    ) : tml_c_phead; OPTIONS(C_PARAM, EXTERN);


    (* get the page header of the preceding page *)

FUNCTION phead_get_prior(
        this_phead : tml_c_phead
    ) : tml_c_phead; OPTIONS(C_PARAM, EXTERN);


    (* get the page number associated with this phead *)

FUNCTION phead_get_page_no(
        this_phead : tml_c_phead
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* get the number of the formatted line that begins this page *)

FUNCTION phead_get_fline_no(
        this_phead : tml_c_phead
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* get the maximum line width *)

FUNCTION phead_get_max_line_width(
        this_phead : tml_c_phead
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* get the maximum height used *)

FUNCTION phead_get_max_used_ht(
        this_phead : tml_c_phead
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* get the number of lines formatted on this page *)

FUNCTION phead_get_line_cnt(
        this_phead : tml_c_phead
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* get the model position associated with the beginning of this page. *)
    (* The second argument points to caller-supplied storage. If all goes *)
    (* well, the return value equals the second argument. *)

FUNCTION phead_get_start(
        this_phead : tml_c_phead;
    VAR pos_p : C_MODEL_POS
    ) : PTR_TO_C_MODEL_POS; OPTIONS(C_PARAM, EXTERN);


    (* get the model position associated with the end of this page. The *)
    (* second argument points to caller-supplied storage. If all goes *)
    (* well, the return value equals the second argument. *)

FUNCTION phead_get_end(
        this_phead : tml_c_phead;
    VAR pos_p : C_MODEL_POS
    ) : PTR_TO_C_MODEL_POS; OPTIONS(C_PARAM, EXTERN);


    (* get the format associated with this page *)

FUNCTION phead_get_format(
        this_phead : tml_c_phead
    ) : tml_c_format; OPTIONS(C_PARAM, EXTERN);


    (* get value of the format_ok member of this page header *)

FUNCTION phead_get_format_ok(
        this_phead : tml_c_phead
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* get the height of this page in pixels *)

FUNCTION phead_get_hi(
        this_phead : tml_c_phead
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* get the width of this page in pixels *)

FUNCTION phead_get_wide(
        this_phead : tml_c_phead
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* first long argument is height in pixels; second if zero indicates *)
    (* search (see below) begins at bottom of page's list of free clines; *)
    (* if nonzero indicates search begins at top of that list. Return the *)
    (* first free cline in the direction specified in that list that has *)
    (* height greater than or equal to the height of this page. *)
    (* The long arguments will be truncated to shorts. *)

FUNCTION phead_get_freeline(
        this_phead : tml_c_phead;
        height : INTEGER32;
        from_top : INTEGER32
    ) : tml_c_cline; OPTIONS(C_PARAM, EXTERN);


    (* get the formatted line at the top of this phead *)

FUNCTION phead_get_tline(
        this_phead : tml_c_phead
    ) : tml_c_cline; OPTIONS(C_PARAM, EXTERN);


    (* get the formatted line at the bottom of this phead *)

FUNCTION phead_get_bline(
        this_phead : tml_c_phead
    ) : tml_c_cline; OPTIONS(C_PARAM, EXTERN);


    (* inquires whether the page associated with this page header is visible *)
    (* on any listed viewport *)

FUNCTION phead_is_visible(
        this_phead : tml_c_phead
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);



    (* TRAITS WHICH ALTER THE PHEAD DATA FIELDS DIRECTLY *)


    (* set the format associated with this phead to the value specified *)

PROCEDURE phead_set_format(
        this_phead : tml_c_phead;
        new_format : tml_c_format
    ); OPTIONS(C_PARAM, EXTERN);


    (* first long argument is height, second argument is width. Set *)
    (* the page's height and width. These long arguments will be *)
    (* truncated to shorts. *)

PROCEDURE phead_set_size(
        this_phead : tml_c_phead;
        hi : INTEGER32;
        wide : INTEGER32
    ); OPTIONS(C_PARAM, EXTERN);


    (* set the model position for the beginning of this page *)

PROCEDURE phead_set_start_pos(
        this_phead : tml_c_phead;
    VAR new_start : C_MODEL_POS
    ); OPTIONS(C_PARAM, EXTERN);


    (* set the model position for the end of this page *)

PROCEDURE phead_set_end_pos(
        this_phead : tml_c_phead;
    VAR new_end : C_MODEL_POS
    ); OPTIONS(C_PARAM, EXTERN);



    (* NAVIGATION AND CREATION FUNCTIONS *)


    (* set the "format_ok" member to zero, signalling that page needs to be *)
    (* reformatted *)

PROCEDURE phead_mark_reformat(
        this_phead : tml_c_phead
    ); OPTIONS(C_PARAM, EXTERN);

    (* if the model doesn't contain any matter to be formatted following *)
    (* this page, return zero. Otherwise, if the next page already exists, *)
    (* update its start position; if long argument is nonzero, reformat *)
    (* the next page and return it. If the next page doesn't yet exist, make *)
    (* a new phead, format it if the long argument is nonzero, and *)
    (* return it. *)

FUNCTION phead_next_page(
        this_phead : tml_c_phead;
        reformat : INTEGER32
    ) : tml_c_phead; OPTIONS(C_PARAM, EXTERN);


    (* if the model doesn't contain any matter to be formatted preceding *)
    (* this page, return zero. Otherwise, if the prior page already exists, *)
    (* update its end position; if the long argument is nonzero, reformat *)
    (* the prior page and return it. If the prior page doesn't yet exist, *)
    (* make a new phead, format it if the long argument is nonzero, set *)
    (* the associated format's first page field to this page, and return *)
    (* the new page *)

FUNCTION phead_prior_page(
        this_phead : tml_c_phead;
        reformat : INTEGER32
    ) : tml_c_phead; OPTIONS(C_PARAM, EXTERN);


    (* Insert a page of material formatted (a) forward from the C_MODEL_POS *)
    (* argument if the long argument is nonzero, (b) backward from the *)
    (* C_MODEL_POS argument if the long argument is zero. If material is *)
    (* formatted forward, insert the new page after this page; if material *)
    (* is formatted backward, insert new the page before this page. *)

FUNCTION phead_insert_page(
    VAR start : C_MODEL_POS;
        after : INTEGER32
    ) : tml_c_phead; OPTIONS(C_PARAM, EXTERN);


    (* If the page needs reformatting, do so. Then if the argument model *)
    (* position isn't formatted on this page, return zero. Otherwise find *)
    (* the conceptual line that contains the text associated with this *)
    (* model position and return that line. *)

FUNCTION phead_mpos_2_cline(
        this_phead : tml_c_phead;
    VAR target : C_MODEL_POS
    ) : tml_c_cline; OPTIONS(C_PARAM, EXTERN);



    (* TRAITS THAT MANIPULATE THE CONCEPTUAL LINES ON THE PAGE *)


    (* Find the head conceptual line containing the indicated model *)
    (* position. If the line is not on the page, return 0. *)

FUNCTION phead_mpos_2_hcline(
        this_phead : tml_c_phead;
    VAR target : C_MODEL_POS
    ) : tml_c_cline; OPTIONS(C_PARAM, EXTERN);


    (* Return all free lines associated with this page to the free store. *)

PROCEDURE phead_free_clines(
        this_phead : tml_c_phead
    ); OPTIONS(C_PARAM, EXTERN);


    (* Integer arguments are x and y coordinates, respectively, in pixels. *)
    (* Search for a conceptual line of size greater than or equal to the *)
    (* cline argument at x and y coordinates less than or equal to those *)
    (* associated with the argument cline. If no such line exists, *)
    (* return -1. If such a line exists, split it if necessary to yield a *)
    (* line of the same size as the cline argument; set the found line's *)
    (* x and y coordinates to the argument values. Replace the argument *)
    (* cline with the new one. The long arguments will be truncated *)
    (* to shorts. *)

FUNCTION phead_line_place(
        this_phead : tml_c_phead;
        place_line : tml_c_cline;
        at_x : INTEGER32;
        at_y : INTEGER32
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);



    (* FORMAT THE PAGE *)


    (* new_model_pos (second C_MODEL_POS* argument) points to *)
    (* caller-supplied storage. Format the page specified by this_phead, *)
    (* starting at the model position specified in argument start. *)
    (* If the page is already formatted, and its starting position matches *)
    (* the model position specified in start, copy its ending model position *)
    (* into new_model_pos. If the page is already formatted, but its *)
    (* starting position doesn't match the model position specified in *)
    (* start, free the conceptual lines associated with the page. Copy the *)
    (* page's ending model position into new_model_pos. If all goes well, *)
    (* the return value equals the third argument. *)

FUNCTION phead_format_page(
        this_phead : tml_c_phead;
    VAR start : C_MODEL_POS;
    VAR new_model_pos : C_MODEL_POS
    ) : PTR_TO_C_MODEL_POS; OPTIONS(C_PARAM, EXTERN);


    (* like phead_format_page, but formats BACKWARD from start argument *)

FUNCTION phead_tamrof_page(
        this_phead : tml_c_phead;
    VAR start : C_MODEL_POS;
    VAR new_model_pos : C_MODEL_POS
    ) : PTR_TO_C_MODEL_POS; OPTIONS(C_PARAM, EXTERN);


    (* like format page, but start indicates the end position of the last *)
    (* correctly formatted line on the page before reformatting is to begins. *)
    (* The model position returned is the end of the last line reformatted. *)

FUNCTION phead_reformat_page(
        this_phead : tml_c_phead;
    VAR start : C_MODEL_POS;
    VAR new_model_pos : C_MODEL_POS
    ) : PTR_TO_C_MODEL_POS; OPTIONS(C_PARAM, EXTERN);




(* FOR CLASS FORMAT *)


    (* allocate a format *)

FUNCTION format_class_alloc : tml_c_format; OPTIONS(C_PARAM, EXTERN);


    (* deallocate a format *)

PROCEDURE format_free(
        this_format : tml_c_format
    ); OPTIONS(C_PARAM, EXTERN);



    (* TRAITS WHICH ALLOW ACCESS TO THE FORMAT DATA *)


    (* get the reference count associated with this format *)

FUNCTION format_get_ref_count(
        this_format : tml_c_format
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* get the model with which this format is associated *)

FUNCTION format_get_model(
        this_format : tml_c_format
    ) : tml_c_model; OPTIONS(C_PARAM, EXTERN);


    (* get the first page at which this format takes effect *)

FUNCTION format_get_first_page(
        this_format : tml_c_format
    ) : tml_c_phead; OPTIONS(C_PARAM, EXTERN);


    (* get the last page which this format affects *)

FUNCTION format_get_last_page(
        this_format : tml_c_format
    ) : tml_c_phead; OPTIONS(C_PARAM, EXTERN);


    (* If this format is not associated with a model, return zero. *)
    (* Otherwise, return the current state in the associated model of the *)
    (* property indexed by the second argument *)

FUNCTION format_inq_state(
        this_format : tml_c_format;
        prop_ind : p_index
    ) : UNIV_PTR; OPTIONS(C_PARAM, EXTERN);


    (* If this format is not associated with a model, return zero. *)
    (* Otherwise, return the state at the argument node of the property *)
    (* indexed by the second argument *)

FUNCTION format_inq_state_at_node(
        this_format : tml_c_format;
        at_node : tml_c_node;
        prop_ind : p_index
    ) : UNIV_PTR; OPTIONS(C_PARAM, EXTERN);


    (* Return page height associated with this format *)

FUNCTION format_get_page_hi(
        this_format : tml_c_format
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* Return page width associated with this format *)

FUNCTION format_get_page_wide(
        this_format : tml_c_format
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* Return maximum line width associated with this format *)

FUNCTION format_get_max_line_width(
        this_format : tml_c_format
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* Return maximum height used on a line *)

FUNCTION format_get_max_used_ht(
        this_format : tml_c_format
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);



    (* TRAITS WHICH ALLOW MANIPULATION OF THE FORMAT DATA *)

    (* set the page size associated with this format: first long *)
    (* argument is height, second is width. The long arguments are *)
    (* truncated to shorts. *)

PROCEDURE format_set_page_size(
        this_format : tml_c_format;
        hi : INTEGER32;
        wide : INTEGER32
    ); OPTIONS(C_PARAM, EXTERN);


    (* set number of pages to be saved. The long argument will be *)
    (* truncated to a short. *)

PROCEDURE format_set_pages_saved(
        this_format : tml_c_format;
        save_num : INTEGER32
    ); OPTIONS(C_PARAM, EXTERN);


    (* set the first page with which this format is associated *)

PROCEDURE format_set_first_page(
        this_format : tml_c_format;
        new_first : tml_c_phead
    ); OPTIONS(C_PARAM, EXTERN);


    (* set the last page which this format affects *)

PROCEDURE format_set_last_page(
        this_format : tml_c_format;
        new_last : tml_c_phead
    ); OPTIONS(C_PARAM, EXTERN);


    (* set the default for this format of the property indexed by the *)
    (* p_index argument to the value indicated by the third argument *)

FUNCTION format_set_state(
        this_format : tml_c_format;
        prop_ind : p_index;
        value : UNIV_PTR
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* set the value of the property indexed by the p_index argument to zero *)

FUNCTION format_unset_state(
        this_format : tml_c_format;
        prop_ind : p_index
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    
    (* TRAITS WHICH MANIPULATE THE FORMAT *)


    (* attach a format to a model *)

PROCEDURE format_attach(
        this_format : tml_c_format;
        to_model : tml_c_model
    ); OPTIONS(C_PARAM, EXTERN);


    (* detach a format from the model associated with it *)

PROCEDURE format_detach(
        this_format : tml_c_format
    ); OPTIONS(C_PARAM, EXTERN);



    (* NAVIGATION TRAITS *)


    (* return the page header associated with the model position argument. *)
    (* If the position falls on or precedes the first page associated with *)
    (* the format, return that page. If the position follows after the last *)
    (* page associated with the format, find that page and return it. *)
    (* If the position is on the last page associated with the format, *)
    (* return that page. Otherwise, start with the first page and reformat *)
    (* as necessary to come up with the page on which the argument model *)
    (* position is formatted. *)

FUNCTION format_mpos_2_phead(
        this_format : tml_c_format;
    VAR find_pos : C_MODEL_POS
    ) : tml_c_phead; OPTIONS(C_PARAM, EXTERN);


    (* return the page header associated with the page number indicated by *)
    (* the long argument. If no such page exists, return zero. *)

FUNCTION format_get_page(
        this_format : tml_c_format;
        page_no : INTEGER32
    ) : tml_c_phead; OPTIONS(C_PARAM, EXTERN);




(* FOR CLASS FONT_TABLE *)


    (* allocate a font table -- use default graphics system function table  *)

FUNCTION font_tbl_class_alloc : tml_c_font_tbl; OPTIONS(C_PARAM, EXTERN);


    (* allocate a font table -- use specified graphics system function table *)

FUNCTION font_tbl_class_alloc_table(
        ftbl : UNIV_PTR
    ) : tml_c_font_tbl; OPTIONS(C_PARAM, EXTERN);


    (* deallocate a font table *)

PROCEDURE font_tbl_free(
        this_font_tbl : tml_c_font_tbl
    ); OPTIONS(C_PARAM, EXTERN);



    (* MEMBER FUNCTIONS TO ACCESS THE DATA *)


    (* get the font's name *)

FUNCTION font_tbl_get_name(
        this_font_tbl : tml_c_font_tbl
    ) : PTR_TO_CHAR; OPTIONS(C_PARAM, EXTERN);


    (* get the number of characters in the font's name *)

FUNCTION font_tbl_get_name_count(
        this_font_tbl : tml_c_font_tbl
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* get the device dependent font id *)

FUNCTION font_tbl_get_handle(
        this_font_tbl : tml_c_font_tbl
    ) : UNIV_PTR; OPTIONS(C_PARAM, EXTERN);


    (* get the height of the font *)

FUNCTION font_tbl_get_hi(
        this_font_tbl : tml_c_font_tbl
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* get the baseline offset from top of font matrix *)

FUNCTION font_tbl_get_baseline(
        this_font_tbl : tml_c_font_tbl
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* if the font is fixed-width, return character width. Else return *)
    (* the width of the character indicated by the long argument *)

FUNCTION font_tbl_get_width(
        this_font_tbl : tml_c_font_tbl;
        charac : INTEGER32
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* get the number of bytes per character *)

FUNCTION font_tbl_get_char_size(
        this_font_tbl : tml_c_font_tbl
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* get the inter-character spacing associated with the font *)

FUNCTION font_tbl_get_icspace(
        this_font_tbl : tml_c_font_tbl
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* return the font's current leading in pixels. The default is the font *)
    (* height minus the maximum character height. It equals the distance *)
    (* from a baseline to the top of the highest possible ascender on the *)
    (* line following. Using this default leading value is the equivalent of *)
    (* "set-solid" leading in typesetting, but the value is calculated *)
    (* differently because we set type (conceptually) down from the upper *)
    (* left corner of the bounding box, not up from the baseline. Calls to *)
    (* set_leading() with nondefault values will change the font height and *)
    (* subsequent calls to get_leading() will reflect this in the leading *)
    (* value returned. *)


FUNCTION font_tbl_get_leading(
        this_font_tbl : tml_c_font_tbl
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);



    (* MEMBER FUNCTIONS TO SET THE DATA *)


    (* set the font's internal fields to the values associated with the font *)
    (* whose name is specified by the char* argument. The long argument *)
    (* is the length of that name. *)

FUNCTION font_tbl_set_info(
        this_font_tbl : tml_c_font_tbl;
    VAR fname_start : CHAR;
        flen : INTEGER32
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* load a font into memory. Zero return value indicates success; *)
    (* -1 indicates failure. *)

FUNCTION font_tbl_load_font(
        this_font_tbl : tml_c_font_tbl
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* change the leading value. See comment under get_leading() above. *)

FUNCTION font_tbl_set_leading(
        this_font_tbl : tml_c_font_tbl;
        lead_pixels : INTEGER32
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* set the intercharacter spacing *)

PROCEDURE font_tbl_set_icspace(
        this_font_tbl : tml_c_font_tbl;
        new_icspace : INTEGER32
    ); OPTIONS(C_PARAM, EXTERN);





(**********************************************************************************
    Objects used in the rendering component of tml

**********************************************************************************)


(* FOR CLASS V_CURSOR *)


    (* allocate a viewport cursor *)

FUNCTION v_cursor_class_alloc : tml_c_v_cursor; OPTIONS(C_PARAM, EXTERN);

    (* deallocate a viewport cursor *)

PROCEDURE v_cursor_free(
        this_v_cursor : tml_c_v_cursor
    ); OPTIONS(C_PARAM, EXTERN);



    (* TRAITS TO ACCESS THE DATA *)


    (* get the viewport associated with a v_cursor *)

FUNCTION v_cursor_get_viewport(
        this_v_cursor : tml_c_v_cursor
    ) : tml_c_view_port; OPTIONS(C_PARAM, EXTERN);


    (* C_SCREEN_XY* argument points to caller-supplied storage *)
    (* get the uncaged xy coordinates of the v_cursor. If all goes well, *)
    (* the return value equals the second argument. *)

FUNCTION v_cursor_get_raw_location(
        this_v_cursor : tml_c_v_cursor;
    VAR xy_p : C_SCREEN_XY
    ) : PTR_TO_C_SCREEN_XY; OPTIONS(C_PARAM, EXTERN);


    (* C_SCREEN_XY* argument points to caller-supplied storage *)
    (* get the caged xy coordinates of the v_cursor. If all goes well, *)
    (* the return value equals the second argument. *)

FUNCTION v_cursor_get_caged_location(
        this_v_cursor : tml_c_v_cursor;
    VAR xy_p : C_SCREEN_XY
    ) : PTR_TO_C_SCREEN_XY; OPTIONS(C_PARAM, EXTERN);


    (* get the viewport position *)

FUNCTION v_cursor_get_view_pos(
        this_v_cursor : tml_c_v_cursor
    ) : tml_c_view_pos; OPTIONS(C_PARAM, EXTERN);


    (* C_SCREEN_XY* argument points to caller-supplied storage *)
    (* get the model position at which the v_cursor rests. If all goes well, *)
    (* the return value equals the second argument *)

FUNCTION v_cursor_get_model_pos(
        this_v_cursor : tml_c_v_cursor;
    VAR pos_p : C_MODEL_POS
    ) : PTR_TO_C_MODEL_POS; OPTIONS(C_PARAM, EXTERN);


    (* Returns the visibility of the cursor. If visibility < 1, the cursor *)
    (* is not drawn; otherwise the cursor is drawn. *)

FUNCTION v_cursor_get_visible(
        this_v_cursor : tml_c_v_cursor
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* get function that draws this v_cursor *)

FUNCTION v_cursor_get_draw_func(
        this_v_cursor : tml_c_v_cursor
    ) : C_CURSOR_DRAW; OPTIONS(C_PARAM, EXTERN);


    (* get height of this v_cursor *)

FUNCTION v_cursor_get_height(
        this_v_cursor : tml_c_v_cursor
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* get width of this v_cursor *)

FUNCTION v_cursor_get_width(
        this_v_cursor : tml_c_v_cursor
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);



    (* TRAITS TO MANIPULATE THE DATA *)


    (* attach the argument v_cursor to the argument view_port *)

PROCEDURE v_cursor_attach(
        this_v_cursor : tml_c_v_cursor;
        to_viewport : tml_c_view_port
    ); OPTIONS(C_PARAM, EXTERN);


    (* detach the argument v_cursor from the argument view_port *)

PROCEDURE v_cursor_detach(
        this_v_cursor : tml_c_v_cursor
    ); OPTIONS(C_PARAM, EXTERN);


    (* Set after_char member to the argument model_pos *)

PROCEDURE v_cursor_set_model_pos(
        this_v_cursor : tml_c_v_cursor;
    VAR new_pos : C_MODEL_POS
    ); OPTIONS(C_PARAM, EXTERN);


    (* If the long argument is zero, increment the visibility of the *)
    (* cursor (see v_cursor_get_visible(), above). If the long argument *)
    (* is nonzero and the cursor is invisible with visibility < 1, make *)
    (* the cursor visible by setting the visibility to 1. Otherwise *)
    (* increment the cursor's visiblity. If the cursor's visibility is 0 *)
    (* (i.e., just below the threshhold of invisibility) the latter case *)
    (* will make the cursor visible. *)

FUNCTION v_cursor_enable(
        this_v_cursor : tml_c_v_cursor;
        force : INTEGER32
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* If the long argument is zero, decrement the visibility of the *)
    (* cursor (see v_cursor_get_visible(), above). If the long argument *)
    (* is nonzero and the cursor visibile with visibility > 1, make the *)
    (* cursor invisible by setting the visibility to 0. Otherwise decrement *)
    (* the cursor's visibility. If the cursor's visibility is 1 (i.e., just *)
    (* above the threshhold of visibility) the latter case will make the *)
    (* cursor invisible. *)

FUNCTION v_cursor_disable(
        this_v_cursor : tml_c_v_cursor;
        force : INTEGER32
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* sets the visibility flag to the indicated value. 0 means that the *)
    (* cursor is not visible, 1 means that the cursor is visible. *)
    (* NOTE--this does not draw or erase the cursor *)

PROCEDURE v_cursor_set_visible(
        this_v_cursor : tml_c_v_cursor;
        is_visible : INTEGER32
    ); OPTIONS(C_PARAM, EXTERN);


    (* Draws the cursor at the current caged position. Note that this *)
    (* function DOES NOT update any of the other cursor information other *)
    (* than cursor visibility. *)
    (* Returns 1 if successful, 0 if unsuccessful *)

FUNCTION v_cursor_draw(
        this_v_cursor : tml_c_v_cursor
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* Erases the cursor at the current caged position. Note that this *)
    (* function DOES NOT update any of the other cursor information other *)
    (* than cursor visibility. Returns 1 if successful, 0 if unsuccessful*)

FUNCTION v_cursor_erase(
        this_v_cursor : tml_c_v_cursor
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* set the function that draws the cursor. *)

PROCEDURE v_cursor_set_draw_func(
        this_v_cursor : tml_c_v_cursor;
        new_func : C_CURSOR_DRAW
    ); OPTIONS(C_PARAM, EXTERN);


    (* C_SCREEN_XY* argument points to caller-supplied storage. *)
    (* Move the cursor in the direction indicated by the long argument *)
    (* (one of enum vp_dir). Returns a pointer to the screen position *)
    (* at which the cursor rests after the move. If all goes well, the *)
    (* return value equals the third argument. *)

FUNCTION v_cursor_move(
        this_v_cursor : tml_c_v_cursor;
        move_dir : vp_dir;
    VAR new_screen_xy : C_SCREEN_XY
    ) : PTR_TO_C_SCREEN_XY; OPTIONS(C_PARAM, EXTERN);


    (* move the cursor to the viewport xy indicated by the second argument *)

FUNCTION v_cursor_xy_set(
        this_v_cursor : tml_c_v_cursor;
    VAR position : C_SCREEN_XY
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* move the cursor to the model position indicated by the second argument *)

FUNCTION v_cursor_mpos_set(
        this_v_cursor : tml_c_v_cursor;
    VAR pos_p : C_MODEL_POS
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);




(* FOR CLASS VIEW_PORT *)


    (* allocate a viewport *)

FUNCTION view_port_class_alloc : tml_c_view_port; OPTIONS(C_PARAM, EXTERN);


    (* deallocate a viewport *)

PROCEDURE view_port_free(
        this_view_port : tml_c_view_port
    ); OPTIONS(C_PARAM, EXTERN);



    (* TRAITS TO ACCESS THE DATA *)


    (* return the bitmap handle associated with the viewport *)

FUNCTION view_port_get_handle(
        this_view_port : tml_c_view_port
    ) : UNIV_PTR; OPTIONS(C_PARAM, EXTERN);


    (* get the width of the viewport *)

FUNCTION view_port_get_width(
        this_view_port : tml_c_view_port
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* get the height of the viewport *)

FUNCTION view_port_get_hi(
        this_view_port : tml_c_view_port
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* get horizontal offset of viewport on conceptual page *)

FUNCTION view_port_get_hoffset(
        view_port_p : UNIV_PTR
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* get top line visible in the viewport *)

FUNCTION view_port_get_top_line(
        this_view_port : tml_c_view_port
    ) : tml_c_view_pos; OPTIONS(C_PARAM, EXTERN);


    (* get bottom line visible in the viewport *)

FUNCTION view_port_get_bottom_line(
        this_view_port : tml_c_view_port
    ) : tml_c_view_pos; OPTIONS(C_PARAM, EXTERN);


    (* get the format associated with the viewport *)

FUNCTION view_port_get_format(
        this_view_port : tml_c_view_port
    ) : tml_c_format; OPTIONS(C_PARAM, EXTERN);


    (* get the cursor associated with the viewport *)

FUNCTION view_port_get_cursor(
        this_view_port : tml_c_view_port
    ) : tml_c_v_cursor; OPTIONS(C_PARAM, EXTERN);


    (* get the id of the foreground color associated with the viewport *)

FUNCTION view_port_get_foreg_id(
        this_view_port : tml_c_view_port
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* get the id of the background color associated with the viewport *)

FUNCTION view_port_get_backg_id(
        this_view_port : tml_c_view_port
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* get the state of the property indexed by the long argument. *)
    (* If there is an entry for this property in the viewport's property *)
    (* state table, return it. Otherwise, if a format is associated with *)
    (* the viewport return the state of the property in the format's *)
    (* property state table (which defaults to the model's property *)
    (* state table setting when no additional setting is made in the *)
    (* format), but if no format is associated with the viewport, *)
    (*  return zero. *)

FUNCTION view_port_inq_state(
        this_view_port : tml_c_view_port;
        prop_ind : p_index
    ) : UNIV_PTR; OPTIONS(C_PARAM, EXTERN);


    (* get the state of the property indexed by the long argument at the *)
    (* argument node. *)
    (* If the viewport's property state table has an entry for this *)
    (* property, return its state. Otherwise return the associated format's *)
    (* property state table entry (which defaults to the model's property *)
    (* state setting), but if no format is associated with the viewport, *)
    (* return 0. *)

FUNCTION view_port_inq_state_at_node(
        this_view_port : tml_c_view_port;
        at_node : tml_c_node;
        prop_ind : p_index
    ) : UNIV_PTR; OPTIONS(C_PARAM, EXTERN);


    (* get the draw marks associaed with the viewport *)

FUNCTION view_port_get_marks(
        view_port_p : tml_c_view_port
    ) : UNIV_PTR; OPTIONS(C_PARAM, EXTERN);



    (* TRAITS TO SET DATA *)


    (* assign the pre-allocated bitmap to the viewport, fill in the width *)
    (* and height. This function assumes that the viewport fills the bitmap. *)


FUNCTION view_port_set_handle(
        this_view_port : tml_c_view_port;
        bitmap_id : tml_c_bitmap_id
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* attach a format to the viewport. If the format argument is zero, *)
    (* create a new one; width and/or depth of zero means that the *)
    (* viewport's dimension(s) (is/are) used to initialize the format's *)
    (* corresponding dimension(s). Returns -1 if allocation is necessary *)
    (* and it fails; returns 0 otherwise *)

FUNCTION view_port_attach_format(
        this_view_port : tml_c_view_port;
        to_format : tml_c_format;
        fx_size : INTEGER32;
        fy_size : INTEGER32
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* detach a format from the viewport. If the format's reference count *)
    (* becomes zero in doing so, the format is deleted. *)

PROCEDURE view_port_detach_format(
        this_view_port : tml_c_view_port
    ); OPTIONS(C_PARAM, EXTERN);


    (* attach a viewport cursor to the viewport. If the argument cursor *)
    (* is attached to another viewport, an error is returned. If the *)
    (* argument C_SCREEN_XY* is NULL, the cursor is set to the upper *)
    (* left hand corner of the screen (coordinates {0,0}); otherwise the *)
    (* coordinates supplied by the C_SCREEN_XY* argument are used. *)

FUNCTION view_port_attach_cursor(
        this_view_port : tml_c_view_port;
        to_cursor : tml_c_v_cursor;
    VAR set_to : C_SCREEN_XY
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* detach a cursor from the viewport *)

PROCEDURE view_port_detach_cursor(
        this_view_port : tml_c_view_port
    ); OPTIONS(C_PARAM, EXTERN);


    (* set the top line of the viewport to be the argument view position *)

PROCEDURE view_port_set_top_line(
        this_view_port : tml_c_view_port;
        new_top : tml_c_view_pos
    ); OPTIONS(C_PARAM, EXTERN);


    (* set the bottom line of the viewport to be the argument view position *)

PROCEDURE view_port_set_bottom_line(
        this_view_port : tml_c_view_port;
        new_bottom : tml_c_view_pos
    ); OPTIONS(C_PARAM, EXTERN);


    (* set the foreground color of the viewport to the color identified *)
    (* by the long argument *)

PROCEDURE view_port_set_foreg_id(
        this_view_port : tml_c_view_port;
        new_id : INTEGER32
    ); OPTIONS(C_PARAM, EXTERN);


    (* set the background color of the viewport to the color identified *)
    (* by the long argument *)

PROCEDURE view_port_set_backg_id(
        this_view_port : tml_c_view_port;
        new_id : INTEGER32
    ); OPTIONS(C_PARAM, EXTERN);


    (* set the default state of the indexed property in the viewport's *)
    (* property state table to the value pointed to by the void* argument. *)

FUNCTION view_port_set_state(
        this_view_port : tml_c_view_port;
        prop_ind : p_index;
        value : UNIV_PTR
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* cancel property override at the viewport level for the property *)
    (* indexed by the p_index argument *)

FUNCTION view_port_unset_state(
        this_view_port : tml_c_view_port;
        prop_ind : p_index
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* add the argument draw_list to the viewport *)

PROCEDURE view_port_add_mark(
        view_port_p : tml_c_view_port;
        new_mark : tml_c_draw_mark
    ); OPTIONS(C_PARAM, EXTERN);


    (* detach the argument draw_list from the viewport *)

PROCEDURE view_port_detach_mark(
        view_port_p : tml_c_view_port;
        del_mark : tml_c_draw_mark
    ); OPTIONS(C_PARAM, EXTERN);



(* ROUTINES WHICH ALLOCATE AND FREE VIEW POSITIONS IN THE VIEWPORT *)


    (* allocate a view position from the view position store for this *)
    (* viewport. If none are available, add some and return one. *)

FUNCTION view_port_get_pos(
        this_view_port : tml_c_view_port
    ) : tml_c_view_pos; OPTIONS(C_PARAM, EXTERN);


    (* return a view_pos to the free heap for the viewport, initializing *)
    (* the contents. When a view_pos is freed, all view_pos to the right *)
    (* of the free view_pos are also freed. *)

PROCEDURE view_port_free_pos(
        this_view_port : tml_c_view_port;
        to_free : tml_c_view_pos
    ); OPTIONS(C_PARAM, EXTERN);


    (* free all the view_pos associated with a viewport. *)

PROCEDURE view_port_free_all_pos(
        this_view_port : tml_c_view_port
    ); OPTIONS(C_PARAM, EXTERN);



    (* ROUTINES THAT ACTUALLY DRAW THINGS *)


    (* clear (an area of) the viewport. First C_SCREEN_XY* is upper left *)
    (* corner of area to be cleared; second is lower right corner. If both *)
    (* C_SCREEN_XY* arguments are set to &zero_zero, the whole viewport is *)
    (* cleared; if only the second C_SCREEN_XY* is set to &zero_zero, the *)
    (* viewport is cleared from the first coordinate to the bottom edge *)
    (* of the viewport. *)

PROCEDURE view_port_clear(
        this_view_port : tml_c_view_port;
    VAR ul : C_SCREEN_XY;
    VAR lr : C_SCREEN_XY
    ); OPTIONS(C_PARAM, EXTERN);


    (* draw the full viewport, starting with the given conceptual line *)

PROCEDURE view_port_draw(
        this_view_port : tml_c_view_port;
        first_line : tml_c_cline;
    VAR where : C_SCREEN_XY
    ); OPTIONS(C_PARAM, EXTERN);


    (* draw the screen, putting the character specified by the *)
    (* C_MODEL_POS* argument at (or as close as possible to) the *)
    (* coordinates supplied in the C_SCREEN_XY* argument *)

PROCEDURE view_port_draw_at(
        this_view_port : tml_c_view_port;
    VAR draw_char : C_MODEL_POS;
    VAR where : C_SCREEN_XY
    ); OPTIONS(C_PARAM, EXTERN);


    (* redraw the viewport *)

PROCEDURE view_port_redraw(
        this_view_port : tml_c_view_port
    ); OPTIONS(C_PARAM, EXTERN);


    (* redraw the viewport, reformatting as we go, from the supplied *)
    (* view_pos until no more is needed. ref_start_mpos indicates the model *)
    (* position which begins the conceptual line which is the start of the *)
    (* view pos contents, rend_start_mpos indicates the model position *)
    (* at which rerendering should start*)

PROCEDURE view_port_redraw_at(
        this_view_port : tml_c_view_port;
    VAR ref_start_mpos : C_MODEL_POS;
    VAR rend_start_mpos : C_MODEL_POS;
        start_vpos : tml_c_view_pos
    ); OPTIONS(C_PARAM, EXTERN);



    (* NAVIGATION ROUTINES *)


    (* convert from the xy coordinates supplied in the argument *)
    (* C_SCREEN_XY* to the view_pos occupying that space in the viewport. *)
    (* If no view_pos occupies the space, get the closest one. *)

FUNCTION view_port_xy_2_vpos(
        this_view_port : tml_c_view_port;
    VAR where : C_SCREEN_XY
    ) : tml_c_view_pos; OPTIONS(C_PARAM, EXTERN);


    (* convert from the xy coordinates supplied in the argument *)
    (* C_SCREEN_XY* to the cline occupying that space in the viewport. *)
    (* If no cline occupies the space, get the closest one. *)

FUNCTION view_port_xy_2_cline(
        this_view_port : tml_c_view_port;
    VAR where : C_SCREEN_XY
    ) : tml_c_cline; OPTIONS(C_PARAM, EXTERN);


    (* C_MODEL_POS* argument points to caller-supplied storage *)
    (* Returns a pointer to the model position associated with the screen *)
    (* position argument. If all goes well, the return value equals the *)
    (* third argument. *)

FUNCTION view_port_xy_2_mpos(
        this_view_port : tml_c_view_port;
    VAR where : C_SCREEN_XY;
    VAR new_model_pos : C_MODEL_POS
    ) : PTR_TO_C_MODEL_POS; OPTIONS(C_PARAM, EXTERN);


    (* find the first view_pos containing the conceptual line. If the line *)
    (* is not on the screen, return 0. *)

FUNCTION view_port_cline_2_vpos(
        this_view_port : tml_c_view_port;
        find_line : tml_c_cline
    ) : tml_c_view_pos; OPTIONS(C_PARAM, EXTERN);


    (* C_SCREEN_XY* argument points to caller-supplied storage *)
    (* Returns a pointer to the screen position associated with the cline *)
    (* argument. If all goes well, the return value equals the third *)
    (* argument. *)

FUNCTION view_port_cline_2_xy(
        this_view_port : tml_c_view_port;
        find_line : tml_c_cline;
    VAR new_screen_xy : C_SCREEN_XY
    ) : PTR_TO_C_SCREEN_XY; OPTIONS(C_PARAM, EXTERN);


    (* return the view_pos containing the supplied character if that *)
    (* character is on the screen. Otherwise return zero. *)

FUNCTION view_port_mpos_2_vpos(
        this_view_port : tml_c_view_port;
    VAR find_char : C_MODEL_POS
    ) : tml_c_view_pos; OPTIONS(C_PARAM, EXTERN);


    (* C_SCREEN_XY* argument points to caller-supplied storage *)
    (* Returns a pointer to the screen position associated with the model *)
    (* position argument. If all goes well, the return value equals the *)
    (* third argument. If the tml_c_view_pos argument is zero, or if the *)
    (* the routine can't find the character indicated by the model position *)
    (* argument at a supplied view position, mpos_2_vpos is called to *)
    (* find the correct view position. Returns a pointer to *)
    (* C_SCREEN_XY {x=0, y=-1} if the character is not on the screen. *)

FUNCTION view_port_mpos_2_xy(
        this_view_port : tml_c_view_port;
    VAR find_char : C_MODEL_POS;
    VAR new_view_pos : C_SCREEN_XY;
        hint : tml_c_view_pos
    ) : PTR_TO_C_SCREEN_XY; OPTIONS(C_PARAM, EXTERN);

    (* returns 1 if the page is currently visible in the viewport, *)
    (* 0 otherwise *)

FUNCTION view_port_is_visible(
        this_view_port : tml_c_view_port;
        page : tml_c_phead
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);



    (* EDITING ROUTINES *)


    (* append string in_string of length count at model position after, *)
    (* reformatting and rendering as needed. *)

FUNCTION view_port_append_string(
        this_view_port : tml_c_view_port;
    VAR in_string_start : CHAR;
        count : INTEGER32;
    VAR after : C_MODEL_POS
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* prepend string in_string of length count to character at model *)
    (* position before, reformatting and rendering as needed. *)

FUNCTION view_port_prepend_string(
        this_view_port : tml_c_view_port;
    VAR in_string_start : CHAR;
        count : INTEGER32;
    VAR before : C_MODEL_POS
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* delete the character at the model position, reformatting and *)
    (* rendering as needed *)

FUNCTION view_port_delete_char(
        this_view_port : tml_c_view_port;
    VAR delete_pos : C_MODEL_POS
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* insert string in_string of length count before the current cursor *)
    (* position, reformatting and rerendering as needed. If the cursor *)
    (* position is invalid, insert before the first character dominated *)
    (* by root. *)

FUNCTION view_port_ins_before_cursor(
        this_view_port : tml_c_view_port;
    VAR in_string_start : CHAR;
        count : INTEGER32
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* insert string in_string of length count after the current cursor *)
    (* position, reformatting and rendering as needed. If the cursor *)
    (* position is invalid, insert before the first character dominated *)
    (* by root. *)

FUNCTION view_port_ins_after_cursor(
        this_view_port : tml_c_view_port;
    VAR in_string_start : CHAR;
        count : INTEGER32
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* append a property vector element referencing the argument property *)
    (* to the property vector for the argument node. Returns 1 on success, *)
    (* zero otherwise *)

FUNCTION view_port_insert_prop_at_node(
        this_view_port : tml_c_view_port;
    VAR to_node : tml_c_node;
        add_prop : tml_c_property
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* perform view_port_insert_prop_at_node on a new node created to dominate *)
    (* all and only the characters within the given pair of model positions. *)
    (* Refresh viewport if necessary. Returns 1 on success, zero otherwise. *)

FUNCTION view_port_insert_prop_on_range(
        view_port_p : tml_c_view_port;
    VAR pos1 : C_MODEL_POS;
    VAR pos2 : C_MODEL_POS;
        add_prop : tml_c_property
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* delete a property from a node; refresh viewport if anything dominated *)
    (* by that node is visible. Return 1 on success, zero otherwise. *)

FUNCTION view_port_delete_prop(
        this_view_port : tml_c_view_port;
        del_prop : tml_c_property;
        from_node : tml_c_node
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* mark a region in the viewport. Make a range in the model, make a *)
    (* model_mark, make a draw_mark, and then add the mark to this viewport *)

FUNCTION view_port_mark_region(
        this_view_port : tml_c_view_port;
    VAR start_mark : C_MODEL_POS;
    VAR end_mark : C_MODEL_POS
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);
                                     



(* FOR CLASS VIEW_POS *)


    (* allocate a view_pos *)

FUNCTION view_pos_class_alloc : tml_c_view_pos; OPTIONS(C_PARAM, EXTERN);


    (* deallocate a view_pos *)

PROCEDURE view_pos_free(
        this_view_pos : tml_c_view_pos
    ); OPTIONS(C_PARAM, EXTERN);



    (* TRAITS TO ACCESS THE DATA *)


    (* get the prior view_pos *)

FUNCTION view_pos_get_prior(
        this_view_pos : tml_c_view_pos
    ) : tml_c_view_pos; OPTIONS(C_PARAM, EXTERN);


    (* get the next view_pos *)

FUNCTION view_pos_get_next(
        this_view_pos : tml_c_view_pos
    ) : tml_c_view_pos; OPTIONS(C_PARAM, EXTERN);


    (* get the view_pos above this one *)

FUNCTION view_pos_get_up(
        this_view_pos : tml_c_view_pos
    ) : tml_c_view_pos; OPTIONS(C_PARAM, EXTERN);


    (* get the view_pos below this one *)

FUNCTION view_pos_get_down(
        this_view_pos : tml_c_view_pos
    ) : tml_c_view_pos; OPTIONS(C_PARAM, EXTERN);


    (* get the viewport with which this view_pos is associated *)

FUNCTION view_pos_get_viewport(
        this_view_pos : tml_c_view_pos
    ) : tml_c_view_port; OPTIONS(C_PARAM, EXTERN);


    (* get the x coordinate of the upper left corner of this view_pos *)

FUNCTION view_pos_get_x(
        this_view_pos : tml_c_view_pos
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* get the y coordinate of the upper left corner of this view_pos *)

FUNCTION view_pos_get_y(
        this_view_pos : tml_c_view_pos
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* get the conceptual line contained by this view_pos *)

FUNCTION view_pos_get_cline(
        this_view_pos : tml_c_view_pos
    ) : tml_c_cline; OPTIONS(C_PARAM, EXTERN);


    (* C_MODEL_POS* argument points to caller-supplied storage. *)
    (* Returns pointer to model position associated with start of this *)
    (* view position. If all goes well, the return value equals the second *)
    (* argument. *)

FUNCTION view_pos_get_start(
        this_view_pos : tml_c_view_pos;
    VAR pos_p : C_MODEL_POS
    ) : PTR_TO_C_MODEL_POS; OPTIONS(C_PARAM, EXTERN);


    (* C_MODEL_POS* argument points to caller-supplied storage. *)
    (* Returns pointer to model position associated with end of this *)
    (* view position. If all goes well, the return value equals the second *)
    (* argument. *)

FUNCTION view_pos_get_end(
        this_view_pos : tml_c_view_pos;
    VAR pos_p : C_MODEL_POS
    ) : PTR_TO_C_MODEL_POS; OPTIONS(C_PARAM, EXTERN);



    (* TRAITS TO MANIPULATE THE DATA *)


    (* set the x coordinate of the upper left corner of this view_pos *)

PROCEDURE view_pos_set_x(
        this_view_pos : tml_c_view_pos;
        new_x : INTEGER32
    ); OPTIONS(C_PARAM, EXTERN);


    (* set the y coordinate of the upper left corner of this view_pos *)

PROCEDURE view_pos_set_y(
        this_view_pos : tml_c_view_pos;
        new_y : INTEGER32
    ); OPTIONS(C_PARAM, EXTERN);


    (* cline argument points to storage not to be reused *)

PROCEDURE view_pos_set_line(
        this_view_pos : tml_c_view_pos;
        new_line : tml_c_cline
    ); OPTIONS(C_PARAM, EXTERN);



    (* MISCELLANEOUS FUNCTIONS *)


    (* disassociate the view_pos from any others it is attached to *)

PROCEDURE view_pos_detach(
        this_view_pos : tml_c_view_pos
    ); OPTIONS(C_PARAM, EXTERN);


    (* set the view_pos's viewport member to the argument viewport *)

PROCEDURE view_pos_attach_port(
        this_view_pos : tml_c_view_pos;
        to_viewport : tml_c_view_port
    ); OPTIONS(C_PARAM, EXTERN);


    (* attach the first view_pos to the second in the direction indicated *)
    (* (one of enum vp_dir). If all goes well, return 0; otherwise *)
    (* return -1. *)

FUNCTION view_pos_attach_pos(
        this_view_pos : tml_c_view_pos;
        to_pos : tml_c_view_pos;
        dir : vp_dir
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* attach a new view_pos to this one in the direction indicated *)
    (* (one of enum vp_dir). If all goes well, return the new view position; *)
    (* otherwise return 0. *)

FUNCTION view_pos_add(
        this_view_pos : tml_c_view_pos;
        dir : vp_dir
    ) : tml_c_view_pos; OPTIONS(C_PARAM, EXTERN);


    (* adjust the xy positions of a set of view positions. First argument *)
    (* is x delta, second is y delta (pixels). A "scrolling" function. *)

PROCEDURE view_pos_adjust(
        this_view_pos : tml_c_view_pos;
        x_delta : INTEGER32;
        y_delta : INTEGER32
    ); OPTIONS(C_PARAM, EXTERN);


    (* return 1 if the model position argument is found between the *)
    (* beginning and end of this view position (inclusive). *)
    (* Return 0 otherwise. *)

FUNCTION view_pos_contains(
        this_view_pos : tml_c_view_pos;
    VAR find_pos : C_MODEL_POS
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);

    


(* UTILITY FUNCTIONS *)


    (* get the type identifier of the default graphics system *)

FUNCTION tml_c_tml_dp_get_dflt_grafsys_type : tml_c_grafsys; OPTIONS(C_PARAM, EXTERN);


    (* get the function table for the default graphics system *)

FUNCTION tml_c_tml_dp_get_dflt_vpftbl : tml_c_vpftbl; OPTIONS(C_PARAM, EXTERN);


    (* set the function table for the default graphics system to the value supplied *)

PROCEDURE tml_c_tml_dp_set_dflt_vpftbl(
        ftbl : tml_c_vpftbl
    ); OPTIONS(C_PARAM, EXTERN);


    (* get the XWindows viewport function table *)

FUNCTION tml_c_tml_dp_get_x_vpftbl : tml_c_vpftbl; OPTIONS(C_PARAM, EXTERN);


    (* get the gpr viewport function table *)

FUNCTION tml_c_tml_dp_get_gpr_vpftbl : tml_c_vpftbl; OPTIONS(C_PARAM, EXTERN);


  (* from the graphics system function table given, get the function associated with the index supplied *)

FUNCTION tml_c_get_graf_func_from_table(
        ftbl : tml_c_vpftbl;
        index : INTEGER32
    ) : GEN_FUNCP; OPTIONS(C_PARAM, EXTERN);


  (* allocate a new property vector in a model *)

FUNCTION tml_c_pvec_alloc(
        to_model : tml_c_model
    ) : tml_c_prop_vec; OPTIONS(C_PARAM, EXTERN);


    (* allocate a new property in a model *)

FUNCTION tml_c_prop_alloc(
        to_model : tml_c_model
    ) : tml_c_property; OPTIONS(C_PARAM, EXTERN);


    (* allocate a new argument in a model *)

FUNCTION tml_c_arg_alloc(
        to_model : tml_c_model
    ) : tml_c_argument; OPTIONS(C_PARAM, EXTERN);


    (* given a start node (first argument) and an end node (second argument), *)
    (* isolate a coherent subtree subsuming all text from start to end, and *)
    (* create any nodes necessary to preserve properties as far up the tree *)
    (* as necessary. Assumes that nodes provided are whole leaf nodes. *)
    (* Returns the root of the isolated subtree. *)

FUNCTION tml_c_make_subtree(
        start_node : tml_c_node;
        end_node : tml_c_node
    ) : tml_c_node; OPTIONS(C_PARAM, EXTERN);


    (* copy text from start point (indicated by first C_MODEL_POS* argument) *)
    (* to end point (second C_MODEL_POS* argument) to the argument model. *)
    (* Startpoint and endpoint, as they are model positions, each consist of *)
    (* a node and character index. All subtree structure and properties are *)
    (* preserved at the target. The target model may be another text file *)
    (* being edited, or it may be a paste buffer. This function does not *)
    (* connect the copied subtree into the target model; must call *)
    (* tml_c_node_connect_node() to do this. Returns root of copied subtree *)
    (* in target model. *)

FUNCTION tml_c_copy_component(
    VAR start_pos : C_MODEL_POS;
    VAR end_pos : C_MODEL_POS;
        to_model : tml_c_model
    ) : tml_c_node; OPTIONS(C_PARAM, EXTERN);


    (* create and return a pointer to a word wrap property, with the value *)
    (* indicated by the integer argument, in the argument model *)

FUNCTION tml_c_make_wrap_prop(
        wrap_on : INTEGER32;
        in_model : tml_c_model
    ) : tml_c_property; OPTIONS(C_PARAM, EXTERN);


    (* create and return a pointer to a margin property, with the values *)
    (* indicated, in the argument model. First long argument is left *)
    (* margin, second is right, third top, fourth bottom. *)

FUNCTION tml_c_make_margin_prop(
        left : INTEGER32;
        right : INTEGER32;
        top : INTEGER32;
        bottom : INTEGER32;
        in_model : tml_c_model
    ) : tml_c_property; OPTIONS(C_PARAM, EXTERN);


    (* create and return a pointer to an invert property, with the value *)
    (* indicated, in the given model *)

FUNCTION tml_c_make_inv_prop(
        inv_on : INTEGER32;
        in_model : tml_c_model
    ) : tml_c_property; OPTIONS(C_PARAM, EXTERN);


    (* create and return a pointer to a font property, with the values *)
    (* indicated, in the given model. Argument char* is font name, integer *)
    (* argument is name length. *)

FUNCTION tml_c_make_font_prop(
    VAR font_name_start : CHAR;
        name_len : INTEGER32;
        in_model : tml_c_model
    ) : tml_c_property; OPTIONS(C_PARAM, EXTERN);


    (* create and return a pointer to a font property, with the values *)
    (* indicated, in the given model. Argument char* is font name, integer *)
    (* argument is name length. The tml_c_grafsys argument specifies *)
    (* a graphics system. *)

FUNCTION tml_c_make_font_prop_grafsys(
    VAR font_name_start : CHAR;
        name_len : INTEGER32;
        in_model : tml_c_model;
        for_grafsys : tml_c_grafsys
    ) : tml_c_property; OPTIONS(C_PARAM, EXTERN);


    (* create and return a pointer to a page size property, with the height *)
    (* and width indicated, in the given model. *)

FUNCTION tml_c_make_page_size_prop(
        width : INTEGER32;
        depth : INTEGER32;
        in_model : tml_c_model
    ) : tml_c_property; OPTIONS(C_PARAM, EXTERN);


    (* create and return a pointer to a tab property, a linked list *)
    (* of tab stops, in the given model *)

FUNCTION tml_c_make_tab_prop(
        default_val : INTEGER32;
        num_stops : INTEGER32;
    VAR tab_st_list : INTEGER32;
        in_model : tml_c_model
    ) : tml_c_property; OPTIONS(C_PARAM, EXTERN);


    (* connect a property to a node at the end of that node's property vector *)

PROCEDURE tml_c_connect_prop(
        add_prop : tml_c_property;
        to_node : tml_c_node
    ); OPTIONS(C_PARAM, EXTERN);


    (* linearize the goo in a model - this function replaces the model's *)
    (* goo heaps with new goo heaps in which the goo is compressed and *)
    (* linearized. This function is called by prune() (see below) so there *)
    (* is no need to linearize goo in a separate step if that function *)
    (* is called. This function deletes all history associated with the *)
    (* model, linearizes goo, then restores the size of the history stack *)
    (* to what it was before this function was called. *)

PROCEDURE tml_c_gc_linearize(
        old_model : tml_c_model
    ); OPTIONS(C_PARAM, EXTERN);


    (* compress objects and linearize goo - this function calls *)
    (* tml_c_gc_linearize() (see above) - it also copies to a new model *)
    (* unique copies of all objects still active in the model, compressing *)
    (* out unused objects. The compressed goo heaps attached to the old *)
    (* model are moved to the new model. *)

FUNCTION tml_c_prune(
        old_model : tml_c_model
    ) : tml_c_model; OPTIONS(C_PARAM, EXTERN);


    (* read a model from the file indicated by the system-dependent *)
    (* file handle. Return a pointer to the new model *)

FUNCTION tml_c_d_read_model_handle(
        file_handle : UNIV_PTR
    ) : tml_c_model; OPTIONS(C_PARAM, EXTERN);


    (* read a model from the file indicated by the pathname and pathname *)
    (* length arguments. Return a pointer to the new model *)

FUNCTION tml_c_d_read_model_path(
    VAR pathname_start : CHAR;
        name_len : INTEGER32
    ) : tml_c_model; OPTIONS(C_PARAM, EXTERN);


    (* read a model from the file indicated by the pathname and pathname *)
    (* length arguments. The oflag and mode arguments are system-dependent *)
    (* quantities. When the function returns, the contents of the *)
    (* file_handle pointer argument is the system-dependent file_handle *)
    (* associated with the file, which remains open. *)

FUNCTION tml_c_d_read_model_open(
    VAR pathname_start : CHAR;
        name_len : INTEGER32;
        oflag : INTEGER32;
        mode : INTEGER32;
    VAR file_handle_p : UNIV_PTR
    ) : tml_c_model; OPTIONS(C_PARAM, EXTERN);


    (* read the ascii file indicated by the argument filename and name *)
    (* length; make a model of the file's contents and return a pointer *)
    (* to the model. *)

FUNCTION tml_c_read_uasc_path(
    VAR pathname_start : CHAR;
        name_len : INTEGER32
    ) : tml_c_model; OPTIONS(C_PARAM, EXTERN);


    (* read the ascii file indicated by the system-dependent file-handle; *)
    (* make a model of the file's contents and return a pointer to the model *)

FUNCTION tml_c_read_uasc_handle(
        file_handle : UNIV_PTR
    ) : tml_c_model; OPTIONS(C_PARAM, EXTERN);


    (* produce a postscript file from a tml model. The output filename is *)
    (* outfilename of length outlen. *)

FUNCTION tml_c_tml_model_print(
        this_model : tml_c_model;
    VAR print_params : C_PRINT_DB;
    VAR outfilename_start : CHAR;
        outlen : INTEGER32
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* produce a postscript file from a tml file. The input filename is *)
    (* infilename of length inlen; the output filename is outfilename of *)
    (* length outlen. *)

FUNCTION tml_c_tml_file_print(
    VAR infilename_start : CHAR;
        inlen : INTEGER32;
    VAR print_params : C_PRINT_DB;
    VAR outfilename_start : CHAR;
        outlen : INTEGER32
    ) : INTEGER32; OPTIONS(C_PARAM, EXTERN);


    (* update history when a call to prop_vec_detach detaches the only *)
    (*   remaining prop_vec in a vector. *)
    (* Call this function when a call to prop_vec_detach() returns 0. *)
    (* Argument "on_node" is the node whose properties member contained *)
    (*   only the one prop_vec "removed". *)

PROCEDURE tml_c_first_pvec_hist(
        on_node : tml_c_node;
        removed : tml_c_prop_vec
    ); OPTIONS(C_PARAM, EXTERN);


    (* update history when a call to argument_detach detaches the only *)
    (*   remaining argument in a property object's entry argument  vector. *)
    (* Call this function when a call to argument_detach() on the entry *)
    (*   argument vector of a property returns 0. *)
    (* Argument "on_prop" is the property whose entry_arg member contained *)
    (*   only the one argument "removed". *)

PROCEDURE tml_c_first_entry_arg_hist(
        on_prop : tml_c_property;
        removed : tml_c_argument
    ); OPTIONS(C_PARAM, EXTERN);


    (* update history when a call to argument_detach detaches the only *)
    (*   remaining argument in a property object's exit argument vector. *)
    (* Call this function when a call to argument_detach() on the exit *)
    (*   argument vector of a property returns 0. *)
    (* Argument "on_prop" is the property whose exit_arg member contained *)
    (*   only the one argument "removed". *)

PROCEDURE tml_c_first_exit_arg_hist(
        on_prop : tml_c_property;
        removed : tml_c_argument
    ); OPTIONS(C_PARAM, EXTERN);



