/**************************************************************************************
    File tml_cxx2.0_linkage_decls.hxx
    Function declarations to externalize TMLib calls
        for use within TMLib

    (c) Copyright Apollo Computer Inc., 1990 (unpublished)
     --------------------------------------------------------------------
    |THE FOLLOWING PROGRAMS ARE THE SOLE PROPERTY OF APOLLO COMPUTER INC.|
    |      AND CONTAIN ITS PROPRIETARY AND CONFIDENTIAL INFORMATION.     |
     --------------------------------------------------------------------
**************************************************************************************/

#ifndef tml_cxx2_0_linkage_decls_hxx
#define tml_cxx2_0_linkage_decls_hxx

#include <tml/tml_c_structs.h>
#include <tml/csm_cxx2.0_linkage_decls.hxx>
#include <dlg/Xlib.h>

/* extern declaration satisfies C++ 2.0 demand that all externally */
/*   visible entry points be explicitly declared. This is required */
/*   for tml_inlib_entry() to be used as an alternate entry point. */
#ifdef __cplusplus
    extern "C" {

        /* dummy class declarations */
        class view_port;
        class tml_type;
        typedef tml_type* p_index;

        /* language library functions */
        void         _main();
        void         exit(int);

#ifdef apollo
        /* functions for searching in the Aegis environment */
        char* tml_aegis_compile_re(char *compile_st,long compile_len,void *out_pat,long out_pat_max,long case_sens);
        long  tml_aegis_match_re(char *search_st, long search_len, void *use_pat);
        long  tml_aegis_min_match(void *pattern);
#endif

        /* initializer for inlib and global library builds */
        void         tml_inlib_entry();

        /* TMLib C interface functions */
        C_MODEL_POS* c_model_pos_alloc();
        void         c_model_pos_free(C_MODEL_POS *this_c_model_pos);
        C_SCREEN_XY* c_screen_xy_alloc();
        void         c_screen_xy_free(C_SCREEN_XY *this_c_screen_xy);
        long         char_set_get_dir_to_char(csm_c_char_set cs_p, unsigned char* c);
        C_MODEL_POS* cline_get_start(void *cline_p, C_MODEL_POS *model_pos_p);
        char*        font_tbl_get_name(void *font_tbl_p);
        long         font_tbl_get_name_count(void *font_tbl_p);
        void*        format_get_first_page(void *format_p);
        void*        model_inq_state_at_node(void *model_p, void *node_p, void* i);
        void*        node_get_contents(void *node_p);
        void*        node_get_model(void *node_p);
        C_MODEL_POS* phead_get_start(void *phead_p, C_MODEL_POS *pos_p);
        void         tml_c_repaint_screen(view_port *vp, long ulx, long uly, long lrx, long lry);
        void         tml_dp_init_draw(void* viewport_handle);
        void*        view_port_get_format(void *view_port_p);
        void*        view_port_get_top_line(void *view_port_p);
        void*        view_port_inq_state(void *view_port_p, p_index prop_ind);
        void         view_port_redraw(void *view_port_p);
        void*        view_port_xy_2_cline(void *view_port_p, C_SCREEN_XY *where);
        C_MODEL_POS* view_port_xy_2_mpos(void *view_port_p, C_SCREEN_XY *where, C_MODEL_POS *model_pos_p);
        void*        view_pos_get_cline(void *view_pos_p);

        /* graphics system functions for XWindows */
        char*        tml_dp_x_get_default_font(long& name_len);
        void*        tml_dp_x_get_fhandle(char *font_name, long name_len);
        long         tml_dp_x_load_font(void *font_handle);
        long         tml_dp_x_get_fcharsize(void *font_handle);
        long         tml_dp_x_get_fcharnum(void *font_handle);
        long         tml_dp_x_get_fchar1(void *font_handle);
        long         tml_dp_x_get_fhi(void *font_handle);
        long         tml_dp_x_get_fpoint(void *font_handle);
        long         tml_dp_x_get_fbline(void *font_handle);
        long         tml_dp_x_is_fixed(void *font_handle);
        short**      tml_dp_x_get_fwidths(void *font_handle);
        long         tml_dp_x_get_ficspace(void *font_handle);
        long         tml_dp_x_set_ficspace(void *font_handle, long new_icspace);
        long         tml_dp_x_get_fspace(void *font_handle);
        void         tml_dp_x_set_fspace(void *font_handle, long new_space);
        long         tml_dp_x_funload(void *font_handle);
        void         tml_dp_x_frelease(void *font_handle);
        void*        tml_dp_x_make_graphic_handle(void *bitmap_id, void *viewport_id);
        void         tml_dp_x_delete_graphic_handle(void *bitmap_id);
        long         tml_dp_x_get_hi(void *bitmap_id);
        long         tml_dp_x_get_wide(void *bitmap_id);
        long         tml_dp_x_get_foreg_id(void *bitmap_id);
        long         tml_dp_x_get_backg_id(void *bitmap_id);
        long         tml_dp_x_get_fill_backg_id(void *bitmap_id);
        long         tml_dp_x_get_fill_obj_id(void *bitmap_id);
        void         tml_dp_x_set_foreg_id(void *bitmap_id, long new_fg_id);
        void         tml_dp_x_set_backg_id(void *bitmap_id, long new_bg_id);
        void         tml_dp_x_set_fill_backg_id(void *bitmap_id, long new_fill_bg_id);
        void         tml_dp_x_set_fill_obj_id(void *bitmap_id, long new_fill_obj_id);
        void         tml_dp_x_set_clip(void *bitmap_id, long clip_ulx, long clip_uly, long clip_lrx, long clip_lry);
        void         tml_dp_x_clear_clip(void *bitmap_id);
        void         tml_dp_x_clear(void *bitmap_id, long ulx, long uly, long lrx, long lry);
        void         tml_dp_x_copy(void *bitmap_id, long src_ulx, long src_uly, long src_lrx, long src_lry, long dst_ulx, long dst_uly);
        void         tml_dp_x_blt(void *bitmap_id, long src_ulx, long src_uly, long src_lrx, long src_lry, long dst_ulx, long dst_uly, long rop_id);
        long         tml_dp_x_string_draw(void *bitmap_id, char *string, long st_count, long wherex, long wherey, void *use_font);
        long         tml_dp_x_string_size(char *string, long st_count, void *use_font);
        void         tml_dp_x_damage_repair(void *bitmap_id);
        long         tml_dp_x_dflt_cursor_draw(void *bitmap_id, long wherex, long wherey,
                                               long height, long width, long erase);
        void*        tml_dp_x_get_grafsys_obj(void* bitmap_id);
        char*        get_x_default_font_name(void* display, long* length);
        char*        set_x_default_font_name(void* display, long* length, char* font_name);

        /* refresh optimization and other functions peculiar to XWindows usage */
        void         tml_dp_set_font_display(Display *display);
        void         tml_dp_add_clip_rect(void* bitmap_id, long ulx, long uly, long width, long height);
        void         tml_dp_record_new_size(void* bitmap_id, long width, long height);
        long         tml_dp_get_creation_x_size(void* bitmap_id);
        long         tml_dp_get_creation_y_size(void* bitmap_id);

        /* graphics system functions for Apollo GPR */
        char*        tml_dp_gpr_get_default_font(long& name_len);
        void*        tml_dp_gpr_get_fhandle(char *font_name, long name_len);
        long         tml_dp_gpr_load_font(void *font_handle);
        long         tml_dp_gpr_get_fcharsize(void *font_handle);
        long         tml_dp_gpr_get_fcharnum(void *font_handle);
        long         tml_dp_gpr_get_fchar1(void *font_handle);
        long         tml_dp_gpr_get_fhi(void *font_handle);
        long         tml_dp_gpr_get_fpoint(void *font_handle);
        long         tml_dp_gpr_get_fbline(void *font_handle);
        long         tml_dp_gpr_is_fixed(void *font_handle);
        short**      tml_dp_gpr_get_fwidths(void *font_handle);
        long         tml_dp_gpr_get_ficspace(void *font_handle);
        long         tml_dp_gpr_set_ficspace(void *font_handle, long new_icspace);
        long         tml_dp_gpr_get_fspace(void *font_handle);
        void         tml_dp_gpr_set_fspace(void *font_handle, long new_space);
        long         tml_dp_gpr_funload(void *font_handle);
        void         tml_dp_gpr_frelease(void *font_handle);
        void*        tml_dp_gpr_make_graphic_handle(void *bitmap_id, void *viewport_id);
        void         tml_dp_gpr_delete_graphic_handle(void *bitmap_id);
        long         tml_dp_gpr_get_hi(void *bitmap_id);
        long         tml_dp_gpr_get_wide(void *bitmap_id);
        long         tml_dp_gpr_get_foreg_id(void *bitmap_id);
        long         tml_dp_gpr_get_backg_id(void *bitmap_id);
        long         tml_dp_gpr_get_fill_backg_id(void *bitmap_id);
        long         tml_dp_gpr_get_fill_obj_id(void *bitmap_id);
        void         tml_dp_gpr_set_foreg_id(void *bitmap_id, long new_fg_id);
        void         tml_dp_gpr_set_backg_id(void *bitmap_id, long new_bg_id);
        void         tml_dp_gpr_set_fill_backg_id(void *bitmap_id, long new_fill_bg_id);
        void         tml_dp_gpr_set_fill_obj_id(void *bitmap_id, long new_fill_obj_id);
        void         tml_dp_gpr_set_clip(void *bitmap_id, long clip_ulx, long clip_uly, long clip_lrx, long clip_lry);
        void         tml_dp_gpr_clear_clip(void *bitmap_id);
        void         tml_dp_gpr_clear(void *bitmap_id, long ulx, long uly, long lrx, long lry);
        void         tml_dp_gpr_copy(void *bitmap_id, long src_ulx, long src_uly, long src_lrx, long src_lry, long dst_ulx, long dst_uly);
        void         tml_dp_gpr_blt(void *bitmap_id, long src_ulx, long src_uly, long src_lrx, long src_lry, long dst_ulx, long dst_uly, long rop_id);
        long         tml_dp_gpr_string_draw(void *bitmap_id, char *string, long st_count, long wherex, long wherey, void *use_font);
        long         tml_dp_gpr_string_size(char *string, long st_count, void *use_font);
        void         tml_dp_gpr_damage_repair(void *bitmap_id);
        long         tml_dp_gpr_dflt_cursor_draw(void *bitmap_id, long wherex, long wherey,
                                                 long height, long width, long erase);
        void*        tml_dp_gpr_get_grafsys_obj(void* bitmap_id);
        char*        get_gpr_default_font_name(long* length);
        char*        set_gpr_default_font_name(char* font_name, long* length);
        void*        tml_dp_get_gpr_genfuncp_tbl();

        }
#endif

#endif

