/**************************************************************************************
    tml_dp_graph.hxx
           graphics package declarations.
           (Contains declarations for machine independent layer, ie.,
           the portable stuff, and higher level dialog oriented graphics
           functions that will run on top of the machine independant
           layer.)
 
    (c) Copyright Apollo Computer Inc., 1987 (unpublished)
     --------------------------------------------------------------------
    |THE FOLLOWING PROGRAMS ARE THE SOLE PROPERTY OF APOLLO COMPUTER INC.|
    |      AND CONTAIN ITS PROPRIETARY AND CONFIDENTIAL INFORMATION.     |
     --------------------------------------------------------------------
**************************************************************************************/

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*                                                                   */
/*                         I M P O R T A N T                         */
/*                                                                   */
/*    This file is written in C, but because it will be included     */
/*    into C and C++ programs, there is a section of program de-     */
/*    clarations written to accomodate C++.   Be careful not to      */
/*    use any features introduced in C++ anywhere in this file       */
/*    except in the above mentioned section.                         */
/*                                                                   */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
 
#ifndef tml_dp_graph_h
#define tml_dp_graph_h
      
#include <tml/tml_prototype_status.h>

#ifdef classy_C
/* C++ macros for low-level rendering functions as used in TML Version 3 and earlier */
#include <tml/tml_objects.hxx>
#define tml_dp_get_default_font      (*(tml_dp_get_dflt_vpftbl()->ptr_2_tml_dp_get_default_font))      
#define tml_dp_get_fhandle           (*(tml_dp_get_dflt_vpftbl()->ptr_2_tml_dp_get_fhandle))           
#define tml_dp_load_font             (*(tml_dp_get_dflt_vpftbl()->ptr_2_tml_dp_load_font))             
#define tml_dp_get_fcharsize         (*(tml_dp_get_dflt_vpftbl()->ptr_2_tml_dp_get_fcharsize))         
#define tml_dp_get_fcharnum          (*(tml_dp_get_dflt_vpftbl()->ptr_2_tml_dp_get_fcharnum))          
#define tml_dp_get_fchar1            (*(tml_dp_get_dflt_vpftbl()->ptr_2_tml_dp_get_fchar1))            
#define tml_dp_get_fhi               (*(tml_dp_get_dflt_vpftbl()->ptr_2_tml_dp_get_fhi))               
#define tml_dp_get_fpoint            (*(tml_dp_get_dflt_vpftbl()->ptr_2_tml_dp_get_fpoint))            
#define tml_dp_get_fbline            (*(tml_dp_get_dflt_vpftbl()->ptr_2_tml_dp_get_fbline))            
#define tml_dp_is_fixed              (*(tml_dp_get_dflt_vpftbl()->ptr_2_tml_dp_is_fixed))              
#define tml_dp_get_fwidths           (*(tml_dp_get_dflt_vpftbl()->ptr_2_tml_dp_get_fwidths))           
#define tml_dp_get_ficspace          (*(tml_dp_get_dflt_vpftbl()->ptr_2_tml_dp_get_ficspace))          
#define tml_dp_set_ficspace          (*(tml_dp_get_dflt_vpftbl()->ptr_2_tml_dp_set_ficspace))          
#define tml_dp_get_fspace            (*(tml_dp_get_dflt_vpftbl()->ptr_2_tml_dp_get_fspace))            
#define tml_dp_set_fspace            (*(tml_dp_get_dflt_vpftbl()->ptr_2_tml_dp_set_fspace))            
#define tml_dp_funload               (*(tml_dp_get_dflt_vpftbl()->ptr_2_tml_dp_funload))               
#define tml_dp_frelease              (*(tml_dp_get_dflt_vpftbl()->ptr_2_tml_dp_frelease))              
#define tml_dp_make_graphic_handle   (*(tml_dp_get_dflt_vpftbl()->ptr_2_tml_dp_make_graphic_handle))   
#define tml_dp_delete_graphic_handle (*(tml_dp_get_dflt_vpftbl()->ptr_2_tml_dp_delete_graphic_handle)) 
#define tml_dp_get_hi                (*(tml_dp_get_dflt_vpftbl()->ptr_2_tml_dp_get_hi))                
#define tml_dp_get_wide              (*(tml_dp_get_dflt_vpftbl()->ptr_2_tml_dp_get_wide))              
#define tml_dp_get_foreg_id          (*(tml_dp_get_dflt_vpftbl()->ptr_2_tml_dp_get_foreg_id))          
#define tml_dp_get_backg_id          (*(tml_dp_get_dflt_vpftbl()->ptr_2_tml_dp_get_backg_id))          
#define tml_dp_get_fill_backg_id     (*(tml_dp_get_dflt_vpftbl()->ptr_2_tml_dp_get_fill_backg_id))     
#define tml_dp_get_fill_obj_id       (*(tml_dp_get_dflt_vpftbl()->ptr_2_tml_dp_get_fill_obj_id))       
#define tml_dp_set_foreg_id          (*(tml_dp_get_dflt_vpftbl()->ptr_2_tml_dp_set_foreg_id))          
#define tml_dp_set_backg_id          (*(tml_dp_get_dflt_vpftbl()->ptr_2_tml_dp_set_backg_id))          
#define tml_dp_set_fill_backg_id     (*(tml_dp_get_dflt_vpftbl()->ptr_2_tml_dp_set_fill_backg_id))     
#define tml_dp_set_fill_obj_id       (*(tml_dp_get_dflt_vpftbl()->ptr_2_tml_dp_set_fill_obj_id))       
#define tml_dp_set_clip              (*(tml_dp_get_dflt_vpftbl()->ptr_2_tml_dp_set_clip))              
#define tml_dp_clear_clip            (*(tml_dp_get_dflt_vpftbl()->ptr_2_tml_dp_clear_clip))            
#define tml_dp_clear                 (*(tml_dp_get_dflt_vpftbl()->ptr_2_tml_dp_clear))                 
#define tml_dp_copy                  (*(tml_dp_get_dflt_vpftbl()->ptr_2_tml_dp_copy))                  
#define tml_dp_blt                   (*(tml_dp_get_dflt_vpftbl()->ptr_2_tml_dp_blt))                   
#define tml_dp_string_draw           (*(tml_dp_get_dflt_vpftbl()->ptr_2_tml_dp_string_draw))           
#define tml_dp_string_size           (*(tml_dp_get_dflt_vpftbl()->ptr_2_tml_dp_string_size))           
#define tml_dp_damage_repair         (*(tml_dp_get_dflt_vpftbl()->ptr_2_tml_dp_damage_repair))         
#define tml_dp_dflt_cursor_draw      (*(tml_dp_get_dflt_vpftbl()->ptr_2_tml_dp_dflt_cursor_draw))      
#define tml_dp_get_grafsys_obj       (*(tml_dp_get_dflt_vpftbl()->ptr_2_tml_dp_get_grafsys_obj))       
#define get_default_font_name        (*(tml_dp_get_dflt_vpftbl()->ptr_2_get_default_font_name))
#define set_default_font_name        (*(tml_dp_get_dflt_vpftbl()->ptr_2_set_default_font_name))
#endif

#ifndef classy_C

#ifdef __STDC__
typedef void (*GENFUNC_P)(...);
extern GENFUNC_P tml_c_get_dp_fp(void* vp_drawfunc_tbl, long index);
#else
typedef (*GENFUNC_P)();
extern GENFUNC_P tml_c_get_dp_fp();
#endif

/* Indices into table of view_port drawing functions */
#define dp_get_default_font_index)          0
#define dp_get_fhandle_index                1
#define dp_load_font_index                  2
#define dp_get_fcharsize_index              3
#define dp_get_fcharnum_index               4
#define dp_get_fchar1_index                 5
#define dp_get_fhi_index                    6
#define dp_get_fpoint_index                 7
#define dp_get_fbline_index                 8
#define dp_is_fixed_index                   9
#define dp_get_fwidths_index               10
#define dp_get_ficspace_index              11
#define dp_set_ficspace_index              12
#define dp_get_fspace_index                13
#define dp_set_fspace_index                14
#define dp_funload_index                   15
#define dp_frelease_index                  16
#define dp_make_graphic_handle_index       17
#define dp_delete_graphic_handle_index     18
#define dp_get_hi_index                    19
#define dp_get_wide_index                  20
#define dp_get_foreg_id_index              21
#define dp_get_backg_id_index              22
#define dp_get_fill_backg_id_index         23
#define dp_get_fill_obj_id_index           24
#define dp_set_foreg_id_index              25
#define dp_set_backg_id_index              26
#define dp_set_fill_backg_id_index         27
#define dp_set_fill_obj_id_index           28
#define dp_set_clip_index                  29
#define dp_clear_clip_index                30 
#define dp_clear_index                     31
#define dp_copy_index                      32
#define dp_blt_index                       33
#define dp_string_draw_index               34
#define dp_string_size_index               35
#define dp_damage_repair_index             36
#define dp_dflt_cursor_draw_index          37
#define dp_get_grafsys_obj_index           38
#define dp_get_default_font_name           39
#define dp_set_default_font_name           40

/* C (ANSI and Vanilla) macros for low-level rendering functions as used in TML Version 3 and earlier */
#define tml_dp_get_default_font      (*(tml_c_get_graf_func_from_table(tml_c_tml_dp_get_dflt_vpftbl(), dp_get_default_font_index))))
#define tml_dp_get_fhandle           (*(tml_c_get_graf_func_from_table(tml_c_tml_dp_get_dflt_vpftbl(), dp_get_fhandle_index)))
#define tml_dp_load_font             (*(tml_c_get_graf_func_from_table(tml_c_tml_dp_get_dflt_vpftbl(), dp_load_font_index)))
#define tml_dp_get_fcharsize         (*(tml_c_get_graf_func_from_table(tml_c_tml_dp_get_dflt_vpftbl(), dp_get_fcharsize_index)))
#define tml_dp_get_fcharnum          (*(tml_c_get_graf_func_from_table(tml_c_tml_dp_get_dflt_vpftbl(), dp_get_fcharnum_index)))
#define tml_dp_get_fchar1            (*(tml_c_get_graf_func_from_table(tml_c_tml_dp_get_dflt_vpftbl(), dp_get_fchar1_index)))
#define tml_dp_get_fhi               (*(tml_c_get_graf_func_from_table(tml_c_tml_dp_get_dflt_vpftbl(), dp_get_fhi_index)))
#define tml_dp_get_fpoint            (*(tml_c_get_graf_func_from_table(tml_c_tml_dp_get_dflt_vpftbl(), dp_get_fpoint_index)))
#define tml_dp_get_fbline            (*(tml_c_get_graf_func_from_table(tml_c_tml_dp_get_dflt_vpftbl(), dp_get_fbline_index)))
#define tml_dp_is_fixed              (*(tml_c_get_graf_func_from_table(tml_c_tml_dp_get_dflt_vpftbl(), dp_is_fixed_index)))
#define tml_dp_get_fwidths           (*(tml_c_get_graf_func_from_table(tml_c_tml_dp_get_dflt_vpftbl(), dp_get_fwidths_index)))
#define tml_dp_get_ficspace          (*(tml_c_get_graf_func_from_table(tml_c_tml_dp_get_dflt_vpftbl(), dp_get_ficspace_index)))
#define tml_dp_set_ficspace          (*(tml_c_get_graf_func_from_table(tml_c_tml_dp_get_dflt_vpftbl(), dp_set_ficspace_index)))
#define tml_dp_get_fspace            (*(tml_c_get_graf_func_from_table(tml_c_tml_dp_get_dflt_vpftbl(), dp_get_fspace_index)))
#define tml_dp_set_fspace            (*(tml_c_get_graf_func_from_table(tml_c_tml_dp_get_dflt_vpftbl(), dp_set_fspace_index)))
#define tml_dp_funload               (*(tml_c_get_graf_func_from_table(tml_c_tml_dp_get_dflt_vpftbl(), dp_funload_index)))
#define tml_dp_frelease              (*(tml_c_get_graf_func_from_table(tml_c_tml_dp_get_dflt_vpftbl(), dp_frelease_index)))
#define tml_dp_make_graphic_handle   (*(tml_c_get_graf_func_from_table(tml_c_tml_dp_get_dflt_vpftbl(), dp_make_graphic_handle_index)))
#define tml_dp_delete_graphic_handle (*(tml_c_get_graf_func_from_table(tml_c_tml_dp_get_dflt_vpftbl(), dp_delete_graphic_handle_index)))
#define tml_dp_get_hi                (*(tml_c_get_graf_func_from_table(tml_c_tml_dp_get_dflt_vpftbl(), dp_get_hi_index)))
#define tml_dp_get_wide              (*(tml_c_get_graf_func_from_table(tml_c_tml_dp_get_dflt_vpftbl(), dp_get_wide_index)))
#define tml_dp_get_foreg_id          (*(tml_c_get_graf_func_from_table(tml_c_tml_dp_get_dflt_vpftbl(), dp_get_foreg_id_index)))
#define tml_dp_get_backg_id          (*(tml_c_get_graf_func_from_table(tml_c_tml_dp_get_dflt_vpftbl(), dp_get_backg_id_index)))
#define tml_dp_get_fill_backg_id     (*(tml_c_get_graf_func_from_table(tml_c_tml_dp_get_dflt_vpftbl(), dp_get_fill_backg_id_index)))
#define tml_dp_get_fill_obj_id       (*(tml_c_get_graf_func_from_table(tml_c_tml_dp_get_dflt_vpftbl(), dp_get_fill_obj_id_index)))
#define tml_dp_set_foreg_id          (*(tml_c_get_graf_func_from_table(tml_c_tml_dp_get_dflt_vpftbl(), dp_set_foreg_id_index)))
#define tml_dp_set_backg_id          (*(tml_c_get_graf_func_from_table(tml_c_tml_dp_get_dflt_vpftbl(), dp_set_backg_id_index)))
#define tml_dp_set_fill_backg_id     (*(tml_c_get_graf_func_from_table(tml_c_tml_dp_get_dflt_vpftbl(), dp_set_fill_backg_id_index)))
#define tml_dp_set_fill_obj_id       (*(tml_c_get_graf_func_from_table(tml_c_tml_dp_get_dflt_vpftbl(), dp_set_fill_obj_id_index)))
#define tml_dp_set_clip              (*(tml_c_get_graf_func_from_table(tml_c_tml_dp_get_dflt_vpftbl(), dp_set_clip_index)))
#define tml_dp_clear_clip            (*(tml_c_get_graf_func_from_table(tml_c_tml_dp_get_dflt_vpftbl(), dp_clear_clip_index)))
#define tml_dp_clear                 (*(tml_c_get_graf_func_from_table(tml_c_tml_dp_get_dflt_vpftbl(), dp_clear_index)))
#define tml_dp_copy                  (*(tml_c_get_graf_func_from_table(tml_c_tml_dp_get_dflt_vpftbl(), dp_copy_index)))
#define tml_dp_blt                   (*(tml_c_get_graf_func_from_table(tml_c_tml_dp_get_dflt_vpftbl(), dp_blt_index)))
#define tml_dp_string_draw           (*(tml_c_get_graf_func_from_table(tml_c_tml_dp_get_dflt_vpftbl(), dp_string_draw_index)))
#define tml_dp_string_size           (*(tml_c_get_graf_func_from_table(tml_c_tml_dp_get_dflt_vpftbl(), dp_string_size_index)))
#define tml_dp_damage_repair         (*(tml_c_get_graf_func_from_table(tml_c_tml_dp_get_dflt_vpftbl(), dp_damage_repair_index)))
#define tml_dp_dflt_cursor_draw      (*(tml_c_get_graf_func_from_table(tml_c_tml_dp_get_dflt_vpftbl(), dp_dflt_cursor_draw_index)))
#define tml_dp_get_grafsys_obj       (*(tml_c_get_graf_func_from_table(tml_c_tml_dp_get_dflt_vpftbl(), dp_get_grafsys_obj_index)))
#define tml_dp_get_default_font_name (*(tml_c_get_graf_func_from_table(tml_c_tml_dp_get_dflt_vpftbl(), dp_get_default_font_name)))
#define tml_dp_set_default_font_name (*(tml_c_get_graf_func_from_table(tml_c_tml_dp_get_dflt_vpftbl(), dp_set_default_font_name)))

#endif

#ifdef classy_C

const long TML_DP_CLEAR            = 0;      /* zero                    */
const long TML_DP_AND              = 1;      /* src AND dst             */
const long TML_DP_AND_REV          = 2;      /* src AND NOT dst         */
const long TML_DP_COPY             = 3;      /* src                     */
const long TML_DP_AND_INV          = 4;      /* (NOT src) AND dst       */
const long TML_DP_NOOP             = 5;      /* dst                     */
const long TML_DP_XOR              = 6;      /* src XOR dst             */
const long TML_DP_OR               = 7;      /* src OR dst              */
const long TML_DP_NOR              = 8;      /* (NOT src) AND (NOT dst) */
const long TML_DP_EQUIV            = 9;      /* (NOT src) XOR dst       */
const long TML_DP_INV              = 10;     /* NOT dst                 */
const long TML_DP_XOR_REV          = 11;     /* src OR (NOT dst)        */
const long TML_DP_COPY_INV         = 12;     /* NOT src                 */
const long TML_DP_XOR_INV          = 13;     /* (NOT src) OR dst        */
const long TML_DP_NAND             = 14;     /* (NOT src) OR (NOT dst)  */
const long TML_DP_SET              = 15;     /* one                     */

#else

#define TML_DP_CLEAR            0            /* zero                    */
#define TML_DP_AND              1            /* src AND dst             */
#define TML_DP_AND_REV          2            /* src AND NOT dst         */
#define TML_DP_COPY             3            /* src                     */
#define TML_DP_AND_INV          4            /* (NOT src) AND dst       */
#define TML_DP_NOOP             5            /* dst                     */
#define TML_DP_XOR              6            /* src XOR dst             */
#define TML_DP_OR               7            /* src OR dst              */
#define TML_DP_NOR              8            /* (NOT src) AND (NOT dst) */
#define TML_DP_EQUIV            9            /* (NOT src) XOR dst       */
#define TML_DP_INV              10           /* NOT dst                 */
#define TML_DP_XOR_REV          11           /* src OR (NOT dst)        */
#define TML_DP_COPY_INV         12           /* NOT src                 */
#define TML_DP_XOR_INV          13           /* (NOT src) OR dst        */
#define TML_DP_NAND             14           /* (NOT src) OR (NOT dst)  */
#define TML_DP_SET              15           /* one                     */

#endif

#endif

