/**************************************************************************************
    tml_type.hxx
    header file for the object definitions and type declarations for unique
        type identifiers in the Text Management Library

    (c) Copyright Apollo Computer Inc., 1989 (unpublished)
     --------------------------------------------------------------------
    |THE FOLLOWING PROGRAMS ARE THE SOLE PROPERTY OF APOLLO COMPUTER INC.|
    |      AND CONTAIN ITS PROPRIETARY AND CONFIDENTIAL INFORMATION.     |
     --------------------------------------------------------------------
**************************************************************************************/

#ifndef tml_type_hxx
#define tml_type_hxx

#ifndef csm_lock_hxx
#include csm_lock_hxx
#endif

/**********************************************************************************
    classes used for identifying object types
**********************************************************************************/

class host_arr {           // parallels host member of APOLLO NCS uuid_$t
public:                    // member public as statically initialized
    unsigned char host[7];

    friend long operator==(host_arr h1, host_arr h2)
        {return( (h1.host[0]==h2.host[0]) &&
                 (h1.host[1]==h2.host[1]) &&
                 (h1.host[2]==h2.host[2]) &&
                 (h1.host[3]==h2.host[3]) &&
                 (h1.host[4]==h2.host[4]) &&
                 (h1.host[5]==h2.host[5]) &&
                 (h1.host[6]==h2.host[6]) );}
    };

class tml_ext_type {  // parallels APOLLO NCS uuid_$t
public:               // members public as statically initialized
    unsigned long  time_high;
    unsigned short time_low;
    unsigned short reserved;
    unsigned char  family;
    host_arr       host;

    friend long operator==(tml_ext_type t1, tml_ext_type t2)
        {return( (t1.time_high == t2.time_high) &&
                 (t1.time_low  == t2.time_low ) &&
                 (t1.reserved  == t2.reserved ) &&
                 (t1.family    == t2.family   ) &&
                 (t1.host      == t2.host     ));}
    void unscramble(endian* their_endian)
        {time_high = their_endian->my_long (time_high);
         time_low  = their_endian->my_short(time_low );
         reserved  = their_endian->my_short(reserved );}
    };

class tml_type { // members public as statically initialized
public:
    tml_ext_type *type;
    void* instance;
    tml_type *next;
    };

class type_queue { // members public as statically initialized
public:
    tml_type *head;
    tml_type *tail;

    void      queue_type(tml_type* new_type);
    };


#endif
// tml_type_hxx

